//  Copyright (c) CNES  2008
//
//  This software is part of CelestLab, a CNES toolbox for Scilab
//
//  This software is governed by the CeCILL  license under French law and
//  abiding by the rules of distribution of free software.  You can  use,
//  modify and/ or redistribute the software under the terms of the CeCILL
//  license as circulated by CEA, CNRS and INRIA at the following URL
//  'http://www.cecill.info'.


// Declarations:


// Code:

// Demo file for 3 body problem functions

env = CL_3b_environment('S-EM','L2');
env.pas=1e-2;
Az = 150e6/env.D;
sens = 0;
t=[0:.1:.25*%pi,.25*%pi+.01:.1:1.1*%pi]

[halo_orb,omega_halo] = CL_3b_halo(env,Az,sens,t);

//plots
graph1 = scf();
xtitle('Halo orbit - ' + string(env.Lpoint),'X','Y')
plot2d(halo_orb(1,:),halo_orb(2,:),5);
plot2d(env.gl,0,-10);
xgrid;

//Manifold computation
epsilon=3e-4;
tint = .75*%pi;

[div_in,conv_in,conv_out,div_out] = CL_3b_manifolds(env,halo_orb,omega_halo,epsilon,tint,['div','conv','-conv','-div']);

graph2 = scf();
xtitle('Halo manifold','X','Y')

for i=1:size(conv_out,3)
plot2d(conv_out(1,:,i),conv_out(2,:,i),2);
end
for i=1:size(conv_in,3)
plot2d(conv_in(1,:,i),conv_in(2,:,i),3);
end
for i=1:size(div_out,3)
plot2d(div_out(1,:,i),div_out(2,:,i),4);
end
for i=1:size(div_in,3)
plot2d(div_in(1,:,i),div_in(2,:,i),5);
end

plot2d(1-env.MU,0,-3);
xstring(1-env.MU,0,'Earth');

plot2d(env.gl,0,-10);
xstring(env.gl,0,env.Lpoint);

plot2d(halo_orb(1,:),halo_orb(2,:),5);

