//  Copyright (c) CNES  2008
//
//  This software is part of CelestLab, a CNES toolbox for Scilab
//
//  This software is governed by the CeCILL  license under French law and
//  abiding by the rules of distribution of free software.  You can  use,
//  modify and/ or redistribute the software under the terms of the CeCILL
//  license as circulated by CEA, CNRS and INRIA at the following URL
//  'http://www.cecill.info'.


// Declarations:


// Code:

// Demo file for 3 body problem functions

env = CL_3b_environment('S-EM','l2');
env.pas=1e-2;

Ax = -30e6/env.D;
phix = %pi;
Az = 100e6/env.D;
phiz = 0;
epsilon=1e-10;
t=[0:0.05:2*%pi];
[orb,omega,nu] = CL_3b_lissajous(env,Ax,phix,Az,phiz,epsilon,t);

//plots
graph1 = scf();

subplot(222);
xgrid;
plot(orb(1,:),orb(3,:),'r');
xtitle('','X','Z');
plot2d(env.gl,0,-10);

subplot(221);
xgrid;
plot(orb(2,:),orb(3,:),'r');
xtitle('','Y','Z');
plot2d(0,0,-10);

subplot(224);
xgrid;
plot(orb(1,:),orb(2,:),'r');
xtitle('','X','Y');
plot2d(env.gl,0,-10);

subplot(223);
xstring(0.5,0.5,'Lissajous orbit');

graph2 =scf();
xtitle('Lissajous orbit','X','Y','Z')
param3d(orb(1,:),orb(2,:),orb(3,:));
line = gce();
line.foreground = 5;

//and now it starts the manifolds computation
epsilon=1e-5;
tint = 1.0*%pi;

[div_in,conv_in,conv_out,div_out] = CL_3b_manifolds(env,orb,nu,epsilon,tint,['div','conv','-conv','-div']);
graph3 = scf();
xtitle('Lissajous manifold','X','Y')
for i=1:size(conv_in,3)
//plot2d(conv_in(1,:,i),conv_in(2,:,i),3);
end
for i=1:size(conv_out,3)
plot2d(conv_out(1,:,i),conv_out(2,:,i),2);
end
for i=1:size(div_out,3)
//plot2d(div_out(1,:,i),div_out(2,:,i),4);
end
for i=1:size(div_in,3)
//plot2d(div_in(1,:,i),div_in(2,:,i),5);
end
plot2d(1-env.MU,0,-3);xstring(1-env.MU,0,'Earth');
plot2d(env.gl,0,-10);xstring(env.gl,0,env.Lpoint);
plot2d(orb(1,:),orb(2,:),5);

