//  Copyright (c) CNES  2008
//
//  This software is part of CelestLab, a CNES toolbox for Scilab
//
//  This software is governed by the CeCILL  license under French law and
//  abiding by the rules of distribution of free software.  You can  use,
//  modify and/ or redistribute the software under the terms of the CeCILL
//  license as circulated by CEA, CNRS and INRIA at the following URL
//  'http://www.cecill.info'.


// Declarations:


// Code:

// Demo file for 3 body problem functions

env = CL_3b_environment('S-EM','l2');

Ax = -30e6/env.D;
phix = 0;
Az = 100e6/env.D;
phiz = 0;
date_init = 0;
epsilon=1e-10;
ttot = 3.6*%pi;
t=[0:.05:3.6*%pi]
orb = CL_3b_lissajous(env,Ax,phix,Az,phiz,epsilon,t);

//plots
graph1 = scf();
subplot(222);xgrid;plot(orb(1,:),orb(3,:),'r');
xtitle('','X','Z');plot2d(env.gl,0,-10);
subplot(221);xgrid;plot(orb(2,:),orb(3,:),'r');
xtitle('','Y','Z');plot2d(0,0,-10);
subplot(224);xgrid;plot(orb(1,:),orb(2,:),'r');
xtitle('','X','Y');plot2d(env.gl,0,-10);
subplot(223);xstring(0.5,0.5,'Lissajous'' orbit');

graph2 =scf();
xtitle('Lissajous orbit','X','Y','Z')
param3d(orb(1,:),orb(2,:),orb(3,:));
line = gce();
line.foreground = 5;

