//  Copyright (c) CNES  2008
//
//  This software is part of CelestLab, a CNES toolbox for Scilab
//
//  This software is governed by the CeCILL  license under French law and
//  abiding by the rules of distribution of free software.  You can  use,
//  modify and/ or redistribute the software under the terms of the CeCILL
//  license as circulated by CEA, CNRS and INRIA at the following URL
//  'http://www.cecill.info'.


// Declarations:
global %CL_eqRad;

// Code:

// Computes possible phasing for a given excentricity,
// inclination and semi major axis boundaries

hmin = 500.e3; 
hmax = 850.e3; 

smaMin = %CL_eqRad + hmin;
smaMax = %CL_eqRad + hmax;
QMin = 2;
QMax = 100;
ecc = 0.001;

sso = 1;
[params]=CL_op_searchRepeatOrbits(smaMin,smaMax,QMin,QMax,ecc,sso) //

//plot results
f=scf(); 
f.immediate_drawing="off";
f.visible = "off"; 

plot((params(:,1)-%CL_eqRad)/1000,params(:,9),'d');   //plot in km
a = gca();
a.grid = [0,0]; 
a.sub_ticks = [0,0];
a.data_bounds = [hmin/1000,0;hmax/1000,QMax];
a.tight_limits="on";

a.x_label.text = 'Altitude [km]';
a.y_label.text = 'Duration of repeat cycle [days]';
a.title.text = 'Sun-synchronous phased orbits for exc = ' + string(ecc);
a.title.font_size=3;
a.x_label.font_size=2;
a.y_label.font_size=2;

a.children.children.mark_size=4;
a.box = "on"; 
f.immediate_drawing="on";
f.visible = "on"; 
