//  Copyright (c) CNES  2008
//
//  This software is part of CelestLab, a CNES toolbox for Scilab
//
//  This software is governed by the CeCILL  license under French law and
//  abiding by the rules of distribution of free software.  You can  use,
//  modify and/ or redistribute the software under the terms of the CeCILL
//  license as circulated by CEA, CNRS and INRIA at the following URL
//  'http://www.cecill.info'.

function %CLevents_p(evts)


// Declarations:


// Code:

  n = size(evts);
  if n>1
    mprintf('Events List: %d Events\n',n);
  else
    mprintf('Events List: %d Event\n',n);
  end

  if n>=1
    [ian,imois,ijour,iheur,imin,seconds]=CL_dat_cjd2cal(evts.date);
    inds = [1:n]
    //evtname(i) = evt_codes.name(evt_codes.code==evl.code(i));
    mprintf(' EvN         Date             Code  Name       x        y        z\n');
    form = '%4d %4.4d/%2.2d/%2.2d %2.2d:%2.2d:%2.2d.%3.3d  %4d %s  %8d %8d %8d\n';
    mprintf(form,inds',ian',imois',ijour',iheur',imin',seconds',1000*(seconds'-int(seconds')),evts.code',..
    evts.name',evts.pos(1,1:n)',evts.pos(2,1:n)',evts.pos(3,1:n)');
  else
    mprintf('Empty Events List\n');
  end
endfunction
