//  Copyright (c) CNES  2008
//
//  This software is part of CelestLab, a CNES toolbox for Scilab
//
//  This software is governed by the CeCILL  license under French law and
//  abiding by the rules of distribution of free software.  You can  use,
//  modify and/ or redistribute the software under the terms of the CeCILL
//  license as circulated by CEA, CNRS and INRIA at the following URL
//  'http://www.cecill.info'.

function output_value = CL_ev_ev2codeName(input_value)


// Declarations:


// Code:

evts_codes = [..
  '  10'  ,'anodec' ,'anc',   ,'ascending node CL_crossing';..
  '  20'  ,'noonst' ,'stc',   ,'noon solar time';..
  '  21'  ,'CL_crosst' ,'stc',   ,'CL_cross specific solar time';..
  '  30'  ,'sebepS' ,'see',   ,'solar eclipse by earth penumbra entry';..
  ' -30'  ,'sebepE' ,'see',   ,'solar eclipse by earth penumbra exit';..
  '  40'  ,'sebmpS' ,'sem',   ,'solar eclipse by moon penumbra entry';..
  ' -40'  ,'sebmpE' ,'sem',   ,'solar eclipse by moon penumbra exit';..
  '  50'  ,'grbleS' ,'gre',   ,'GRB rise above earth limb';..
  ' -50'  ,'grbleE' ,'gre',   ,'GRB set under earth limb';..
  '  51'  ,'gre20S' ,'gre',   ,'GRB rise above earth limb + 20 degs';..
  ' -51'  ,'gre20E' ,'gre',   ,'GRB set under earth limb + 20 degs';..
  '  61'  ,'grm20S' ,'grm',   ,'GRB / moon center above 20 degs';..
  ' -61'  ,'grm20E' ,'grm',   ,'GRB / moon center below 20 degs';..
  '  70'  ,'satanS' ,'saa',   ,'SAA entry';..
  ' -70'  ,'satanE' ,'saa',   ,'SAA exit';..
  ' 100'  ,'sgvS_'  ,'sgv',   ,'start geometric visibility';..
  '-100'  ,'sgvE_'  ,'sgv',   ,'end geometric visibility';..
  ' 200'  ,'rfS_'   ,'sav',   ,'start RF visibility';..
  '-200'  ,'rfE_'   ,'sav',   ,'end RF visibility';..
  ' 500'  ,'senS_'  ,'ssv',   ,'entry sensor';..
  '-500'  ,'senS_'  ,'ssv',   ,'exit sensor';..
  ' 800'  ,'ormans' ,' ',     ,'orbital manoeuvre start';..
  '-800'  ,'ormane' ,' ',     ,'orbital manoeuvre end';..
  ' 900'  ,'atmanS' ,'man',   ,'attitude manoeuvre start';..
  '-900'  ,'atmanE' ,'man',   ,'attitude manoeuvre end'];

  if typeof(input_value)=='string'
    icode = find(evts_codes(:,3)==input_value);
    codes = evstr(evts_codes(:,1));
    output_value = codes(icode(1));
  elseif typeof(input_value)=='constant'
    codes = evstr(evts_codes(:,1));
    code = int(input_value);
    [f c] = find(code.*.ones(size(codes,1),1)==codes.*.ones(1,size(code,2)));
    output_value = evts_codes(f,2)';
  end

endfunction

