//  Copyright (c) CNES  2008
//
//  This software is part of CelestLab, a CNES toolbox for Scilab
//
//  This software is governed by the CeCILL  license under French law and
//  abiding by the rules of distribution of free software.  You can  use,
//  modify and/ or redistribute the software under the terms of the CeCILL
//  license as circulated by CEA, CNRS and INRIA at the following URL
//  'http://www.cecill.info'.

function [C] = CL_colMult(A,B)
// Multiplication of each columns of a matrix
//
// Calling Sequence
// [C] = CL_colMult(A,B)
//
// Description
// <itemizedlist><listitem>
// A DOCUMENTER
// </listitem>
// <listitem>Last update : 09/10/2009</listitem>
// </itemizedlist>
//
// Parameters
// A: Matrix (1 x N)
// B: Matrix (p x N)
// C: Matrix (p x N) such as : C(:,i) =  A(:,i) .* B(:,i)
//
// Authors
// CNES - DCT/SB
//
// Examples
// A = [ 1 2 3];
// B = [ 1 2 3 ; 4 5 6 ; 7 8 9];
// C = CL_colMult(A,B)


// Declarations:


// Code:

B_type = typeof(B);

if B_type=='constant'
  p = size(B,1);
  N = size(B,2);
  if(p == 3)
    C = [ A(1,:) .* B(1,:) ;
        A(1,:) .* B(2,:) ;
      A(1,:) .* B(3,:)];
  elseif(p == 2)
    C = [ A(1,:) .* B(1,:) ;
        A(1,:) .* B(2,:)] ;
  elseif(p == 1)
    C = A.*B;
  else
    C = zeros(B);
    if(N > p)
    for i= 1:p
       C(i,:) = A(1,:) .* B(i,:);
    end
  else
    for i= 1:N
       C(:,i) = A(1,i) .* B(:,i);
    end
  end
  end
else
  error('type of first argument not valid in this function');
end

endfunction
