//  Copyright (c) CNES  2008
//
//  This software is part of CelestLab, a CNES toolbox for Scilab
//
//  This software is governed by the CeCILL  license under French law and
//  abiding by the rules of distribution of free software.  You can  use,
//  modify and/ or redistribute the software under the terms of the CeCILL
//  license as circulated by CEA, CNRS and INRIA at the following URL
//  'http://www.cecill.info'.

function [w] = CL_cross(u,v)
// Vector cross product
//
// Calling Sequence
// [w] = CL_cross(u,v)
//
// Description
// <itemizedlist><listitem>
// Cross product of vectors <emphasis role="bold">u</emphasis> and <emphasis role="bold">v</emphasis>.
// </listitem>
// <listitem>Last update : 22/02/2007</listitem>
// </itemizedlist>
//
// Parameters
// u: matrix of vectors (3xN)
// v: matrix of vectors (3xN)
// w: CL_cross products (3xN)
//
// See also
// CL_dot
//
// Authors
// CNES - DCT/SB
//

// Declarations:


// Code:

w=[u(2,:).*v(3,:)-u(3,:).*v(2,:);...
    u(3,:).*v(1,:)-u(1,:).*v(3,:);...
   u(1,:).*v(2,:)-u(2,:).*v(1,:)];

endfunction
