program co_car2geod

use mslib

real(pm_reel), dimension(3)              ::  pos_car      ! positions vitesses en coordonnees cartesiennes
real(pm_reel)                            ::  r_equa, r_equa_init        ! rayon equatorial terrestre
real(pm_reel)                            ::  apla, apla_init            ! applatissement terrestre
type(tm_geodesique)                      ::  pos_geod     ! longitude, latitude, hauteur geodesiques
type(tm_code_retour)                     ::  code_retour
real(pm_reel), dimension (3,3)           ::  jacob        ! jacobienne
integer :: j

!!*************
!!NOMINAL CASES

call mc_GRS1980(code_retour, apla=apla_init, r_equa=r_equa_init)
r_equa = r_equa_init
apla = 0.00335281317789691_pm_reel !apla like scilab

!*********************
!CASE 1: standard case
pos_car(1)   = 4637885.347_pm_reel
pos_car(2)   = 121344.608_pm_reel
pos_car(3)   = 4362452.869_pm_reel
call mt_car_geod ( pos_car, r_equa, apla, pos_geod, code_retour, jacob = jacob )
print *, pos_car
print *, pos_geod
print *, r_equa, apla, 0
do j=1,3
	print *, jacob(j,1), jacob(j,2), jacob(j,3) 
end do
!*********************

!*********************
!CASE 2: standard case 
pos_car(1)   = r_equa
pos_car(2:3) = 0._pm_reel
call mt_car_geod ( pos_car, r_equa, apla, pos_geod, code_retour )
print *, pos_car
print *, pos_geod
print *, r_equa, apla, 0
!*********************

!*********************
!CASE 3: longitude=0
pos_car(1)   =  6378400.0_pm_reel
pos_car(2)   =  0._pm_reel
pos_car(3)   = 6379000.0_pm_reel
call mt_car_geod ( pos_car, r_equa, apla, pos_geod, code_retour )
print *, pos_car
print *, pos_geod
print *, r_equa, apla, 0
!*********************

!*********************
!CASE 4: longitude=pi
pos_car(1)   = -6379999.0_pm_reel
pos_car(2)   =  0._pm_reel
pos_car(3)   = 6379000.0_pm_reel
call mt_car_geod ( pos_car, r_equa, apla, pos_geod, code_retour )
print *, pos_car
print *, pos_geod
print *, r_equa, apla, 0
!*********************

!*********************
!CASE 5: longitude=pi/2
pos_car(1)   = 0.0_pm_reel
pos_car(2)   = 0.0_pm_reel
pos_car(3)   = 7000000.0_pm_reel
call mt_car_geod ( pos_car, r_equa, apla, pos_geod, code_retour )
print *, pos_car
print *, pos_geod
print *, r_equa, apla, 0
!*********************

!*********************
!CASE 6: equator case
pos_car(1)   = 6379888._pm_reel
pos_car(2)   = 6377000.0_pm_reel
pos_car(3)   = 0.0_pm_reel
call mt_car_geod ( pos_car, r_equa, apla, pos_geod, code_retour )
print *, pos_car
print *, pos_geod
print *, r_equa, apla, 0
!*********************

!*********************
!CASE 7: initialisation interior ellipsoid (3 roots)
r_equa       = 6378.137_pm_reel
inv_apla     = 298.257_pm_reel
apla         = 1._pm_reel/inv_apla
pos_car(1)   = 9.219_pm_reel
pos_car(2)   = -5.322_pm_reel
pos_car(3)   = 6056.743_pm_reel
call mt_car_geod ( pos_car, r_equa, apla, pos_geod, code_retour )
print *, pos_car
print *, pos_geod
print *, r_equa, apla, 0
!*********************

!*********************
!CASE 8: initialisation interior ellipsoid (less than 3 roots)
r_equa       = 6378.137_pm_reel
inv_apla     = 298.257_pm_reel
apla         = 1._pm_reel/inv_apla
pos_car(1)   = 1366.863_pm_reel
pos_car(2)   = - 789.159_pm_reel
pos_car(3)   =-5848.988_pm_reel
call mt_car_geod ( pos_car, r_equa, apla, pos_geod, code_retour )
print *, pos_car
print *, pos_geod
print *, r_equa, apla, 0
!*********************

!*********************
!CASE 9: initialisation exterior ellipsoid (with pos_geod%haut>r_equa)
r_equa       = 6378.137_pm_reel
inv_apla     = 298.257_pm_reel
apla         = 1._pm_reel/inv_apla
pos_car(1)   = 5722.966_pm_reel
pos_car(2)   = -3304.156_pm_reel
pos_car(3)   = -24621.187_pm_reel
call mt_car_geod ( pos_car, r_equa, apla, pos_geod, code_retour )
print *, pos_car
print *, pos_geod
print *, r_equa, apla, 0
!*********************

end program co_car2geod