program co_car2kep

use mslib

real(pm_reel) :: mu
type(tm_orb_kep) :: kep
real(pm_reel), dimension(3) :: pos_car
real(pm_reel), dimension(3) :: vit_car
type(tm_code_retour) :: code_retour
real(pm_reel), dimension(6,6) :: jacob
integer :: j

mu = .39860047e15_pm_reel

!!*************
!!NOMINAL CASES

!*********************
!CASE 1: elliptic case
pos_car =(/-26655470.0_pm_reel,29881667.0_pm_reel,-113657.0_pm_reel/)
vit_car =(/-1125.0_pm_reel,-1122.0_pm_reel,195.0_pm_reel/)
call mv_car_kep (mu, pos_car, vit_car, kep, code_retour,jacob = jacob)
print *, pos_car
print *, vit_car
print *, kep%a, kep%e, kep%i
print *, kep%pom, kep%gom, kep%M
do j=1,6
	print *, jacob(j,1), jacob(j,2), jacob(j,3) 
	print *, jacob(j,4), jacob(j,5), jacob(j,6) 
end do
!*********************

!*********************
!CASE 2: hyperbolic case
pos_car =(/-15.0_pm_reel,31.0_pm_reel,11.0_pm_reel/)
vit_car =(/-97.0e5_pm_reel,-49.0e5_pm_reel,19.0e5_pm_reel/)
call mv_car_kep (mu, pos_car, vit_car, kep, code_retour,jacob = jacob)
print *, pos_car
print *, vit_car
print *, kep%a, kep%e, kep%i
print *, kep%pom, kep%gom, kep%M
do j=1,6
	print *, jacob(j,1), jacob(j,2), jacob(j,3) 
	print *, jacob(j,4), jacob(j,5), jacob(j,6) 
end do
!*********************

!*********************
!CASE 3: parabolic case
pos_car =(/-1.98888041021530_pm_reel,1.97616996400156_pm_reel, 1.97616996400152_pm_reel/)
vit_car =(/-0.151918816665038e8_pm_reel,0.898492038104791e6_pm_reel,0.898492038104750e6_pm_reel/)
call mv_car_kep (mu, pos_car, vit_car, kep, code_retour,jacob = jacob)
print *, pos_car
print *, vit_car
print *, kep%a, kep%e, kep%i
print *, kep%pom, kep%gom, kep%M
do j=1,6
	print *, jacob(j,1), jacob(j,2), jacob(j,3) 
	print *, jacob(j,4), jacob(j,5), jacob(j,6) 
end do
!*********************

end program co_car2kep
