program co_cirequa2kep

use mslib

type(tm_orb_cir_equa) :: CIR_EQUA
type(tm_orb_kep) :: KEP
type(tm_code_retour) :: CODE_RETOUR
real(pm_reel), dimension(6,6) :: jacob

!!*************
!!NOMINAL CASES

!****************************
!CASE 1: Random standard case !!falta validar jacobia en aquest cas
CIR_EQUA%a =     42166.712_pm_reel
CIR_EQUA%ex =   -7.900e-06_pm_reel
CIR_EQUA%ey =    1.100e-04_pm_reel
CIR_EQUA%ix =    1.200e-04_pm_reel
CIR_EQUA%iy =   -1.16e-04_pm_reel
CIR_EQUA%pso_M = 5.300_pm_reel

call mv_cir_equa_kep(CIR_EQUA,KEP,CODE_RETOUR,jacob=jacob)

print *, CIR_EQUA%a, CIR_EQUA%ex, CIR_EQUA%ey
print *, CIR_EQUA%ix, CIR_EQUA%iy, CIR_EQUA%pso_M
print *, KEP%a, KEP%e, KEP%i
print *, KEP%pom, KEP%gom, KEP%M
do j=1,6
	print *, jacob(j,1), jacob(j,2), jacob(j,3) 
	print *, jacob(j,4), jacob(j,5), jacob(j,6) 
end do
!****************************

!!*************
!!DEGRADED CASES

!****************************
!CASE 2: equatorial orbit
CIR_EQUA%a =     42166.712_pm_reel
CIR_EQUA%ex =   -7.900e-06_pm_reel
CIR_EQUA%ey =    1.100e-04_pm_reel
CIR_EQUA%ix =    0_pm_reel
CIR_EQUA%iy =    0_pm_reel
CIR_EQUA%pso_M = 5.300_pm_reel

call mv_cir_equa_kep(CIR_EQUA,KEP,CODE_RETOUR)

print *, CIR_EQUA%a, CIR_EQUA%ex, CIR_EQUA%ey
print *, CIR_EQUA%ix, CIR_EQUA%iy, CIR_EQUA%pso_M
print *, KEP%a, KEP%e, KEP%i
print *, KEP%pom, KEP%gom, KEP%M
!****************************

!****************************
!CASE 3: circular non equatorial orbit
CIR_EQUA%a =     42166.712_pm_reel
CIR_EQUA%ex =    0_pm_reel
CIR_EQUA%ey =    0_pm_reel
CIR_EQUA%ix =    1.200e-04_pm_reel
CIR_EQUA%iy =   -1.16e-04_pm_reel
CIR_EQUA%pso_M = 5.300_pm_reel

call mv_cir_equa_kep(CIR_EQUA,KEP,CODE_RETOUR)

print *, CIR_EQUA%a, CIR_EQUA%ex, CIR_EQUA%ey
print *, CIR_EQUA%ix, CIR_EQUA%iy, CIR_EQUA%pso_M
print *, KEP%a, KEP%e, KEP%i
print *, KEP%pom, KEP%gom, KEP%M
!****************************

!****************************
!CASE 4: circular equatorial orbit
CIR_EQUA%a =     42166.712_pm_reel
CIR_EQUA%ex =    0_pm_reel
CIR_EQUA%ey =    0_pm_reel
CIR_EQUA%ix =    0_pm_reel
CIR_EQUA%iy =    0_pm_reel
CIR_EQUA%pso_M = 5.300_pm_reel

call mv_cir_equa_kep(CIR_EQUA,KEP,CODE_RETOUR)

print *, CIR_EQUA%a, CIR_EQUA%ex, CIR_EQUA%ey
print *, CIR_EQUA%ix, CIR_EQUA%iy, CIR_EQUA%pso_M
print *, KEP%a, KEP%e, KEP%i
print *, KEP%pom, KEP%gom, KEP%M
!****************************

end program co_cirequa2kep
