program co_kep2car

use mslib

real(pm_reel) :: MU
type(tm_orb_kep) :: KEP
real(pm_reel), dimension(3) :: POS_CAR
real(pm_reel), dimension(3) :: VIT_CAR
type(tm_code_retour) :: CODE_RETOUR
real(pm_reel), dimension(6,6) :: jacob

MU = .39860047e15_pm_reel

!!*************
!!NOMINAL CASES

!*********************
!CASE 1: elliptic case
KEP%a =   24464560.0_pm_reel
KEP%e =   0.7311_pm_reel
KEP%i =   0.122138_pm_reel
KEP%pom = 3.10686_pm_reel
KEP%gom = 1.00681_pm_reel
KEP%M =   0.048363_pm_reel
call mv_kep_car(MU,KEP,POS_CAR,VIT_CAR,CODE_RETOUR,jacob=jacob)
print *, KEP%a, KEP%e, KEP%i
print *, KEP%pom, KEP%gom, KEP%M
print *, POS_CAR
print *, VIT_CAR
do j=1,6
	print *, jacob(j,1), jacob(j,2), jacob(j,3) 
	print *, jacob(j,4), jacob(j,5), jacob(j,6) 
end do
!*********************

!*********************
!CASE 2: hyperbolic case
KEP%a =   4.0_pm_reel
KEP%e =   5.0_pm_reel
KEP%i =   0.349065850399_pm_reel
KEP%pom = 0.104719755120e1_pm_reel
KEP%gom = 0.959931088597_pm_reel
KEP%M =   0.174532925199_pm_reel
call mv_kep_car(MU,KEP,POS_CAR,VIT_CAR,CODE_RETOUR,jacob=JACOB)
print *, KEP%a, KEP%e, KEP%i
print *, KEP%pom, KEP%gom, KEP%M
print *, POS_CAR
print *, VIT_CAR
do j=1,6
	print *, jacob(j,1), jacob(j,2), jacob(j,3) 
	print *, jacob(j,4), jacob(j,5), jacob(j,6) 
end do
!*********************

!*********************
!CASE 3: parabolic case ! falta jacobia
KEP%a =   4.0_pm_reel
KEP%e =   1.0_pm_reel
KEP%i =   0.785398163397_pm_reel
KEP%pom = 0.785398163397e1_pm_reel
KEP%gom = 0.000000000000_pm_reel
KEP%M =   0.523598775598_pm_reel
call mv_kep_car(MU,KEP,POS_CAR,VIT_CAR,CODE_RETOUR,jacob=JACOB)
print *, KEP%a, KEP%e, KEP%i
print *, KEP%pom, KEP%gom, KEP%M
print *, POS_CAR
print *, VIT_CAR
do j=1,6
	print *, jacob(j,1), jacob(j,2), jacob(j,3) 
	print *, jacob(j,4), jacob(j,5), jacob(j,6) 
end do
!*********************

end program co_kep2car
