program fr_ref2topoN

use mslib

type(tm_geodesique)            :: orig_topo  ! coordonnees geodesiques de l'origine du repere topocentrique
real(pm_reel)                  :: r_equa     ! rayon equatorial
real(pm_reel)                  :: apla       ! aplatissement
real(pm_reel), dimension(3)    :: pos_ref    ! position dans le repere terrestre de reference
real(pm_reel), dimension(3)    :: pos_topo   ! position dans le repere topocentrique Nord
type(tm_code_retour)           ::  code_retour
real(pm_reel), dimension(3)    :: vit_ref    ! vitesse dans le repere terrestre de reference
real(pm_reel), dimension(3)    :: vit_topo   ! vitesse dans le repere topocentrique Nord
real(pm_reel), dimension(6,6)  :: jacob      ! jacobien de la transformation
real(pm_reel), dimension(3)  :: pos_car    ! coordonnees cartesiennes de la station origine du repere topocentrique

!!*************
!!NOMINAL CASES

call mc_GRS1980(code_retour,r_equa=r_equa,apla=apla)
apla = 0.00335281317789691_pm_reel !as in spacelab
!***************************
!CAS 1: Standard random case
pos_ref(1) = 4812257.7369_pm_reel
pos_ref(2) = 4037898.4218_pm_reel
pos_ref(3) = 1100306.6376_pm_reel
vit_ref(1) = 117.7753_pm_reel
vit_ref(2) = 7.4467_pm_reel
vit_ref(3) = 37.061_pm_reel
pos_car(1) = 0.481223149418667e+07_pm_reel
pos_car(2) = 0.403794167191173e+07_pm_reel
pos_car(3) = 0.110025722467858e+07_pm_reel
call mt_car_geod(pos_car, r_equa, apla, orig_topo, code_retour)
call mt_ref_topo_N (orig_topo,r_equa,apla,pos_ref,pos_topo,code_retour,vit_ref = vit_ref,vit_topo = vit_topo,jacob = jacob)
print *, pos_ref
print *, vit_ref
print *, orig_topo
print *, pos_topo
print *, vit_topo
do j=1,6
	print *, jacob(j,1), jacob(j,2), jacob(j,3)
	print *, jacob(j,4), jacob(j,5), jacob(j,6)
end do
!***************************

end program fr_ref2topoN