program fr_topoN2ref

use mslib

type(tm_geodesique)                       :: orig_topo  ! coordonnees geodesiques de l'origine du repere topocentrique
real(pm_reel)                             :: r_equa     ! rayon equatorial
real(pm_reel)                             :: apla       ! aplatissement
real(pm_reel),dimension(3)                :: pos_topo   ! position dans le repere topocentrique Nord
real(pm_reel), dimension(3)               :: pos_ref    ! position dans le repere terrestre de reference
type(tm_code_retour)                      :: code_retour
real(pm_reel), dimension(3)               :: sta
real(pm_reel), dimension(3)               :: vit_topo   ! vitesse dans le repere topocentrique Nord
real(pm_reel), dimension(3)               :: vit_ref    ! vitesse dans le repere terrestre de reference
real(pm_reel), dimension(6,6)             :: jacob      ! jacobien de la transformation


!!*************
!!NOMINAL CASES

call mc_GRS1980(code_retour,r_equa=r_equa,apla=apla)
apla = 0.00335281317789691_pm_reel !as in spacelab
!***************************
!CAS 1: Standard random case
pos_topo(1) = 50._pm_reel
pos_topo(2) = 50._pm_reel
pos_topo(3) = 0._pm_reel
vit_topo(1) = 20._pm_reel
vit_topo(2) = 70._pm_reel
vit_topo(3) = 100._pm_reel
sta(1) =  0.481223149418667e+07_pm_reel
sta(2) =  0.403794167191173e+07_pm_reel
sta(3) =  0.110025722467858e+07_pm_reel
call mt_car_geod(sta, r_equa, apla, orig_topo, code_retour)
call mt_topo_N_ref (orig_topo, r_equa, apla, pos_topo, pos_ref, code_retour, vit_topo, vit_ref, jacob)
print *, pos_topo
print *, vit_topo
print *, orig_topo
print *, pos_ref
print *, vit_ref
do j=1,6
	print *, jacob(j,1), jacob(j,2), jacob(j,3)
	print *, jacob(j,4), jacob(j,5), jacob(j,6)
end do
!***************************

end program fr_topoN2ref