//  Copyright (c) CNES  2008
//
//  This software is part of CelestLab, a CNES toolbox for Scilab
//
//  This software is governed by the CeCILL  license under French law and
//  abiding by the rules of distribution of free software.  You can  use,
//  modify and/ or redistribute the software under the terms of the CeCILL
//  license as circulated by CEA, CNRS and INRIA at the following URL
//  'http://www.cecill.info'.


// Declarations:


// Code:

mode(-1);
path=get_absolute_file_path('test_co_car2geod.sce');
chdir(path);
rep1=unix_g('co_car2geod.exe');

[fd,err] = mopen('co_car2geod_mslib.test','w');

for i=1:size(rep1,1)
  mfprintf(fd,rep1(i)+'\n');
end
mclose(fd);

M_mslib_prov=fscanfMat('co_car2geod_mslib.test'); //provisional
[row,col] = size(M_mslib_prov);
M_mslib = [];
M_scilab = [];
i_car = 1;
i_geod = 2;
i_era = 3;
i_jac13 = 4;
i_jac23 = 5;
i_jac33 = 6;
car_mslib = M_mslib_prov(i_car,:);
geod_mslib = M_mslib_prov(i_geod,:);
er = M_mslib_prov(i_era,1);
apla = M_mslib_prov(i_era,2);
jacob_mslib = [M_mslib_prov(i_jac13,:);...
               M_mslib_prov(i_jac23,:);...
               M_mslib_prov(i_jac33,:);];
M_mslib(1,:) = [car_mslib,er,apla,geod_mslib,jacob_mslib(2,:),jacob_mslib(1,:),jacob_mslib(3,:)];

car = M_mslib(1,1:3);
[geod,jacob]=co_car2geod(car',er',apla');
M_scilab(1,:) = [car,er,apla,geod',jacob(1,:),jacob(2,:),jacob(3,:)];

i_car = 7:3:row-2;
i_geod = 8:3:row-1;
i_era = 9:3:row;
car_mslib = M_mslib_prov(i_car,:);
geod_mslib = M_mslib_prov(i_geod,:);
er = M_mslib_prov(i_era,1);
apla = M_mslib_prov(i_era,2);
M_mslib(2:9,:) = [car_mslib,er,apla,geod_mslib,zeros(8,9)];

car = M_mslib(2:9,1:3);
[geod]=co_car2geod(car',er',apla');
M_scilab(2:9,:) = [car,er,apla,geod',zeros(8,9)];

aux = M_mslib(:,6)
M_mslib(:,6) = M_mslib(:,7)
M_mslib(:,7) = aux

fprintfMat('co_car2geod_mslib.test',M_mslib,'%.17f');
fprintfMat('co_car2geod_scilab.test',M_scilab,'%.17f');

//compare values
name='co_car2geod';
epsilon=%eps;
uepsilon = strsubst(string(epsilon),'D','e'); //convert precision to unix numeric format
cmd = 'difference -p '+uepsilon+' -ref '+name+'_scilab.test -res '+name+'_mslib.test';
str = '('+cmd+')>'+TMPDIR+'/unix.out 2>'+TMPDIR+'/unix.err;echo $?>'+TMPDIR+'/unix.status';
unix(str); //difference execution

status = read(TMPDIR+'/unix.status',1,1); //0: no difference between files
                                          //1: at least one difference between files
                                          //2: error
output = read(TMPDIR+'/unix.out',-1,1,'(a)');
errors = read(TMPDIR+'/unix.err',-1,1,'(a)');

//write validation
[fd,err] = mopen(name+'.validation','w');
mfprintf(fd,name+'(SpaceLab) vs. mt_car_geod(MSLIB)\n---\n');
for i=1:size(output,1)
  mfprintf(fd,output(i)+'\n');
end

if status~=0
  mfprintf(fd,'\n---error messages---\n');
  for i=1:size(errors,1)
    mfprintf(fd,errors(i)+'\n');
  end
end

mclose(fd);
