//  Copyright (c) CNES  2008
//
//  This software is part of CelestLab, a CNES toolbox for Scilab
//
//  This software is governed by the CeCILL  license under French law and
//  abiding by the rules of distribution of free software.  You can  use,
//  modify and/ or redistribute the software under the terms of the CeCILL
//  license as circulated by CEA, CNRS and INRIA at the following URL
//  'http://www.cecill.info'.


// Declarations:


// Code:

mode(-1);
path=get_absolute_file_path('test_co_cir2car.sce');
chdir(path);
rep1=unix_g('co_cir2car.exe');

[fd,err] = mopen('co_cir2car_mslib.test','w');

for i=1:size(rep1,1)
  mfprintf(fd,rep1(i)+'\n');
end
mclose(fd);

M_mslib_prov=fscanfMat('co_cir2car_mslib.test'); //provisional
[row,col] = size(M_mslib_prov);
li = row;
i_c1 = 1:li:row-15;
i_c2 = 2:li:row-14;
i_p = 3:li:row-13;
i_s = 4:li:row-12;
i_jac13 = 5:li:row-11;
i_jac16 = 6:li:row-10;
i_jac23 = 7:li:row-9;
i_jac26 = 8:li:row-8;
i_jac33 = 9:li:row-7;
i_jac36 = 10:li:row-6;
i_jac43 = 11:li:row-5;
i_jac46 = 12:li:row-4;
i_jac53 = 13:li:row-3;
i_jac56 = 14:li:row-2;
i_jac63 = 15:li:row-1;
i_jac66 = 16:li:row;
c1_mslib = M_mslib_prov(i_c1,:);
c2_mslib = M_mslib_prov(i_c2,:);
p_mslib = M_mslib_prov(i_p,:);
s_mslib = M_mslib_prov(i_s,:);
jacob_mslib = [M_mslib_prov(i_jac13,:),M_mslib_prov(i_jac16,:);...
               M_mslib_prov(i_jac23,:),M_mslib_prov(i_jac26,:);...
               M_mslib_prov(i_jac33,:),M_mslib_prov(i_jac36,:);...
               M_mslib_prov(i_jac43,:),M_mslib_prov(i_jac46,:);...
               M_mslib_prov(i_jac53,:),M_mslib_prov(i_jac56,:);...
               M_mslib_prov(i_jac63,:),M_mslib_prov(i_jac66,:)];
M_mslib = [c1_mslib,c2_mslib,p_mslib,s_mslib,...
           jacob_mslib(1,:),jacob_mslib(2,:),jacob_mslib(3,:),jacob_mslib(4,:),jacob_mslib(5,:),jacob_mslib(6,:)];

cir = M_mslib(:,1:6);
[p,s,jacob]=co_cir2car(cir');
M_scilab = [cir,p',s',jacob(1,:),jacob(2,:),jacob(3,:),jacob(4,:),jacob(5,:),jacob(6,:)];

fprintfMat('co_cir2car_mslib.test',M_mslib,'%.17f');
fprintfMat('co_cir2car_scilab.test',M_scilab,'%.17f');

//compare values
name='co_cir2car';
epsilon=%eps;
uepsilon = strsubst(string(epsilon),'D','e'); //convert precision to unix numeric format
cmd = 'difference -p '+uepsilon+' -ref '+name+'_scilab.test -res '+name+'_mslib.test';
str = '('+cmd+')>'+TMPDIR+'/unix.out 2>'+TMPDIR+'/unix.err;echo $?>'+TMPDIR+'/unix.status';
unix(str); //difference execution

status = read(TMPDIR+'/unix.status',1,1); //0: no difference between files
                                          //1: at least one difference between files
                                          //2: error
output = read(TMPDIR+'/unix.out',-1,1,'(a)');
errors = read(TMPDIR+'/unix.err',-1,1,'(a)');

//write validation
[fd,err] = mopen(name+'.validation','w');
mfprintf(fd,name+'(SpaceLab) vs. mv_cir_car(MSLIB)\n---\n');
for i=1:size(output,1)
  mfprintf(fd,output(i)+'\n');
end

if status~=0
  mfprintf(fd,'\n---error messages---\n');
  for i=1:size(errors,1)
    mfprintf(fd,errors(i)+'\n');
  end
end

mclose(fd);
