//  Copyright (c) CNES  2008
//
//  This software is part of CelestLab, a CNES toolbox for Scilab
//
//  This software is governed by the CeCILL  license under French law and
//  abiding by the rules of distribution of free software.  You can  use,
//  modify and/ or redistribute the software under the terms of the CeCILL
//  license as circulated by CEA, CNRS and INRIA at the following URL
//  'http://www.cecill.info'.


// Declarations:


// Code:

mode(-1);
path=get_absolute_file_path('test_co_cirequa2kep.sce');
chdir(path);

rep1=unix_g('co_cirequa2kep.exe');

[fd,err] = mopen('co_cirequa2kep_mslib.test','w');

for i=1:size(rep1,1)
  mfprintf(fd,rep1(i)+'\n');
end
mclose(fd);

M_mslib_prov=fscanfMat('co_cirequa2kep_mslib.test'); //provisional
[row,col] = size(M_mslib_prov);
M_mslib = [];
M_scilab = [];
//case with jacobian
i_ce1 = 1;
i_ce2 = 2;
i_kep1 = 3;
i_kep2 = 4;
i_jac13 = 5;
i_jac16 = 6;
i_jac23 = 7;
i_jac26 = 8;
i_jac33 = 9;
i_jac36 = 10;
i_jac43 = 11;
i_jac46 = 12;
i_jac53 = 13;
i_jac56 = 14;
i_jac63 = 15;
i_jac66 = 16;
ce1_mslib = M_mslib_prov(i_ce1,:);
ce2_mslib = M_mslib_prov(i_ce2,:);
kep1_mslib = M_mslib_prov(i_kep1,:);
kep2_mslib = M_mslib_prov(i_kep2,:);
jacob_mslib = [M_mslib_prov(i_jac13,:),M_mslib_prov(i_jac16,:);...
               M_mslib_prov(i_jac23,:),M_mslib_prov(i_jac26,:);...
               M_mslib_prov(i_jac33,:),M_mslib_prov(i_jac36,:);...
               M_mslib_prov(i_jac43,:),M_mslib_prov(i_jac46,:);...
               M_mslib_prov(i_jac53,:),M_mslib_prov(i_jac56,:);...
               M_mslib_prov(i_jac63,:),M_mslib_prov(i_jac66,:)];
M_mslib(1,:) = [ce1_mslib,ce2_mslib,kep1_mslib,kep2_mslib,...
           jacob_mslib(1,:),jacob_mslib(2,:),jacob_mslib(3,:),jacob_mslib(4,:),jacob_mslib(5,:),jacob_mslib(6,:)];

cir_equa = M_mslib(:,1:6);
[kep,jacob]=co_cirequa2kep(cir_equa');
M_scilab(1,:) = [cir_equa,kep',jacob(1,:),jacob(2,:),jacob(3,:),jacob(4,:),jacob(5,:),jacob(6,:)];

//cases without jacobian
i_ce1 = 17:4:row-3;
i_ce2 = 18:4:row-2;
i_kep1 = 19:4:row-1;
i_kep2 = 20:4:row;
ce1_mslib = M_mslib_prov(i_ce1,:);
ce2_mslib = M_mslib_prov(i_ce2,:);
kep1_mslib = M_mslib_prov(i_kep1,:);
kep2_mslib = M_mslib_prov(i_kep2,:);
M_mslib(2:4,:) = [ce1_mslib,ce2_mslib,kep1_mslib,kep2_mslib,zeros(3,36)];

cir_equa = M_mslib(2:4,1:6);
[kep]=co_cirequa2kep(cir_equa');
M_scilab(2:4,:) = [cir_equa,kep',zeros(3,36)];

fprintfMat('co_cirequa2kep_mslib.test',M_mslib,'%.17f');
fprintfMat('co_cirequa2kep_scilab.test',M_scilab,'%.17f');

//compare values
name='co_cirequa2kep';
epsilon=%eps;
uepsilon = strsubst(string(epsilon),'D','e'); //convert precision to unix numeric format
cmd = 'difference -p '+uepsilon+' -ref '+name+'_scilab.test -res '+name+'_mslib.test';
str = '('+cmd+')>'+TMPDIR+'/unix.out 2>'+TMPDIR+'/unix.err;echo $?>'+TMPDIR+'/unix.status';
unix(str); //difference execution

status = read(TMPDIR+'/unix.status',1,1); //0: no difference between files
                                          //1: at least one difference between files
                                          //2: error
output = read(TMPDIR+'/unix.out',-1,1,'(a)');
errors = read(TMPDIR+'/unix.err',-1,1,'(a)');

//write validation
[fd,err] = mopen(name+'.validation','w');
mfprintf(fd,name+'(SpaceLab) vs. mv_cir_equa_kep(MSLIB)\n---\n');
for i=1:size(output,1)
  mfprintf(fd,output(i)+'\n');
end

if status~=0
  mfprintf(fd,'\n---error messages---\n');
  for i=1:size(errors,1)
    mfprintf(fd,errors(i)+'\n');
  end
end

mclose(fd);


