//  Copyright (c) CNES  2008
//
//  This software is part of CelestLab, a CNES toolbox for Scilab
//
//  This software is governed by the CeCILL  license under French law and
//  abiding by the rules of distribution of free software.  You can  use,
//  modify and/ or redistribute the software under the terms of the CeCILL
//  license as circulated by CEA, CNRS and INRIA at the following URL
//  'http://www.cecill.info'.


// Declarations:


// Code:

mode(-1);
path=get_absolute_file_path('test_co_geod2car.sce');
chdir(path);

rep1=unix_g('co_geod2car.exe');

[fd,err] = mopen('co_geod2car_mslib.test','w');

for i=1:size(rep1,1)
  mfprintf(fd,rep1(i)+'\n');
end
mclose(fd);

M_mslib_prov=fscanfMat('co_geod2car_mslib.test'); //provisional
[row,col] = size(M_mslib_prov);
i_pg = 1
i_pc = 2
i_jac13 = 3
i_jac23 = 4
i_jac33 = 5
pg_mslib = M_mslib_prov(i_pg,:);
pc_mslib = M_mslib_prov(i_pc,:);
jacob_mslib = [M_mslib_prov(i_jac13,:);
               M_mslib_prov(i_jac23,:);
               M_mslib_prov(i_jac33,:)];
M_mslib = [pg_mslib,pc_mslib,jacob_mslib(1,:),jacob_mslib(2,:),jacob_mslib(3,:)];

pos = M_mslib(:,1:3);
[p_car,jacob]=co_geod2car(pos');
M_scilab = [pos,p_car',jacob(1,:),jacob(2,:),jacob(3,:)];

fprintfMat('co_geod2car_mslib.test',M_mslib,'%.17f');
fprintfMat('co_geod2car_scilab.test',M_scilab,'%.17f');

//compare values
name='co_geod2car';
epsilon=%eps;
uepsilon = strsubst(string(epsilon),'D','e'); //convert precision to unix numeric format
cmd = 'difference -p '+uepsilon+' -ref '+name+'_scilab.test -res '+name+'_mslib.test';
str = '('+cmd+')>'+TMPDIR+'/unix.out 2>'+TMPDIR+'/unix.err;echo $?>'+TMPDIR+'/unix.status';
unix(str); //difference execution

status = read(TMPDIR+'/unix.status',1,1); //0: no difference between files
                                          //1: at least one difference between files
                                          //2: error
output = read(TMPDIR+'/unix.out',-1,1,'(a)');
errors = read(TMPDIR+'/unix.err',-1,1,'(a)');

//write validation
[fd,err] = mopen(name+'.validation','w');
mfprintf(fd,name+'(SpaceLab) vs. mt_geod_car(MSLIB)\n---\n');
for i=1:size(output,1)
  mfprintf(fd,output(i)+'\n');
end

if status~=0
  mfprintf(fd,'\n---error messages---\n');
  for i=1:size(errors,1)
    mfprintf(fd,errors(i)+'\n');
  end
end

mclose(fd);


