//  Copyright (c) CNES  2008
//
//  This software is part of CelestLab, a CNES toolbox for Scilab
//
//  This software is governed by the CeCILL  license under French law and
//  abiding by the rules of distribution of free software.  You can  use,
//  modify and/ or redistribute the software under the terms of the CeCILL
//  license as circulated by CEA, CNRS and INRIA at the following URL
//  'http://www.cecill.info'.


// Declarations:


// Code:

mode(-1);
path=get_absolute_file_path('test_co_kep2car.sce');
chdir(path);

global %mu;
old_mu = %mu;
%mu = 3.9860047e14;

rep1=unix_g('co_kep2car.exe');

[fd,err] = mopen('co_kep2car_mslib.test','w');

for i=1:size(rep1,1)
  mfprintf(fd,rep1(i)+'\n');
end
mclose(fd);

M_mslib_prov=fscanfMat('co_kep2car_mslib.test'); //provisional
[row,col] = size(M_mslib_prov);
li = 16;
i_kep1 = 1:li:row;
i_kep2 = 2:li:row;
i_p = 3:li:row;
i_s = 4:li:row;
i_jac13 = 5:li:row;
i_jac16 = 6:li:row;
i_jac23 = 7:li:row;
i_jac26 = 8:li:row;
i_jac33 = 9:li:row;
i_jac36 = 10:li:row;
i_jac43 = 11:li:row;
i_jac46 = 12:li:row;
i_jac53 = 13:li:row;
i_jac56 = 14:li:row;
i_jac63 = 15:li:row;
i_jac66 = 16:li:row;
kep1_mslib = M_mslib_prov(i_kep1,:);
kep2_mslib = M_mslib_prov(i_kep2,:);
p_mslib = M_mslib_prov(i_p,:);
s_mslib = M_mslib_prov(i_s,:);
jacob1_mslib = [M_mslib_prov(i_jac13,:),M_mslib_prov(i_jac16,:)];
jacob2_mslib = [M_mslib_prov(i_jac23,:),M_mslib_prov(i_jac26,:)];
jacob3_mslib = [M_mslib_prov(i_jac33,:),M_mslib_prov(i_jac36,:)];
jacob4_mslib = [M_mslib_prov(i_jac43,:),M_mslib_prov(i_jac46,:)];
jacob5_mslib = [M_mslib_prov(i_jac53,:),M_mslib_prov(i_jac56,:)];
jacob6_mslib = [M_mslib_prov(i_jac63,:),M_mslib_prov(i_jac66,:)];
M_mslib = [kep1_mslib,kep2_mslib,p_mslib,s_mslib,...
          jacob1_mslib,jacob2_mslib,jacob3_mslib,jacob4_mslib,jacob5_mslib,jacob6_mslib];

kep = M_mslib(:,1:6);
[p,s,jacob]=co_kep2car(kep');
for i=1:row/li
  M_scilab(i,:) = [kep(i,:),p(:,i)',s(:,i)',jacob(1,:,i),jacob(2,:,i),jacob(3,:,i),jacob(4,:,i),jacob(5,:,i),jacob(6,:,i)];
end


fprintfMat('co_kep2car_mslib.test',M_mslib,'%.17f');
fprintfMat('co_kep2car_scilab.test',M_scilab,'%.17f');

//compare values
name='co_kep2car';
epsilon=%eps;
uepsilon = strsubst(string(epsilon),'D','e'); //convert precision to unix numeric format
cmd = 'difference -p '+uepsilon+' -ref '+name+'_scilab.test -res '+name+'_mslib.test';
str = '('+cmd+')>'+TMPDIR+'/unix.out 2>'+TMPDIR+'/unix.err;echo $?>'+TMPDIR+'/unix.status';
unix(str); //difference execution

status = read(TMPDIR+'/unix.status',1,1); //0: no difference between files
                                          //1: at least one difference between files
                                          //2: error
output = read(TMPDIR+'/unix.out',-1,1,'(a)');
errors = read(TMPDIR+'/unix.err',-1,1,'(a)');

//write validation
[fd,err] = mopen(name+'.validation','w');
mfprintf(fd,name+'(SpaceLab) vs. mv_kep_car(MSLIB)\n---\n');
for i=1:size(output,1)
  mfprintf(fd,output(i)+'\n');
end

if status~=0
  mfprintf(fd,'\n---error messages---\n');
  for i=1:size(errors,1)
    mfprintf(fd,errors(i)+'\n');
  end
end

mclose(fd);

%mu = old_mu;
