//  Copyright (c) CNES  2008
//
//  This software is part of CelestLab, a CNES toolbox for Scilab
//
//  This software is governed by the CeCILL  license under French law and
//  abiding by the rules of distribution of free software.  You can  use,
//  modify and/ or redistribute the software under the terms of the CeCILL
//  license as circulated by CEA, CNRS and INRIA at the following URL
//  'http://www.cecill.info'.


// Declarations:


// Code:

mode(-1);
path=get_absolute_file_path('test_da_cal2cjd.sce');
chdir(path);
rep1=unix_g('da_cal2cjd.exe');

[fd,err] = mopen('da_cal2cjd_mslib.test','w');

for i=1:size(rep1,1)
  mfprintf(fd,rep1(i)+'\n');
end
mclose(fd);

M_mslib_prov=fscanfMat('da_cal2cjd_mslib.test'); //provisional
[row,col] = size(M_mslib_prov);
i1 = 1:3:row-2;
i2 = 2:3:row-1;
i3 = 3:3:row;
year_mslib = M_mslib_prov(i1,1);
month_mslib = M_mslib_prov(i1,2);
day_mslib = M_mslib_prov(i1,3);
hour_mslib = M_mslib_prov(i2,1);
min_mslib = M_mslib_prov(i2,2);
sec_mslib = M_mslib_prov(i2,3);
day1950_mslib = M_mslib_prov(i3,1);
sec1950_mslib = M_mslib_prov(i3,2);
M_mslib = [year_mslib,month_mslib,day_mslib,hour_mslib,min_mslib,sec_mslib,day1950_mslib,sec1950_mslib];

year = M_mslib(:,1);
month = M_mslib(:,2);
day = M_mslib(:,3);
hour = M_mslib(:,4);
minute = M_mslib(:,5);
second = M_mslib(:,6);
[cjd]=da_cal2cjd(year',month',day',hour',minute',second');
cjd_day = int(cjd)
cjd_sec = (cjd-int(cjd))*24*3600
M_scilab = [year,month,day,hour,minute,second,cjd_day',cjd_sec'];

fprintfMat('da_cal2cjd_mslib.test',M_mslib,'%.17f');
fprintfMat('da_cal2cjd_scilab.test',M_scilab,'%.17f');

//compare values
name='da_cal2cjd';
epsilon=%eps;
uepsilon = strsubst(string(epsilon),'D','e'); //convert precision to unix numeric format
cmd = 'difference -p '+uepsilon+' -ref '+name+'_scilab.test -res '+name+'_mslib.test';
str = '('+cmd+')>'+TMPDIR+'/unix.out 2>'+TMPDIR+'/unix.err;echo $?>'+TMPDIR+'/unix.status';
unix(str); //difference execution

status = read(TMPDIR+'/unix.status',1,1); //0: no difference between files
                                          //1: at least one difference between files
                                          //2: error
output = read(TMPDIR+'/unix.out',-1,1,'(a)');
errors = read(TMPDIR+'/unix.err',-1,1,'(a)');

//write validation
[fd,err] = mopen(name+'.validation','w');
mfprintf(fd,name+'(SpaceLab) vs. md_calend_julien(MSLIB)\n---\n');
for i=1:size(output,1)
  mfprintf(fd,output(i)+'\n');
end

if status~=0
  mfprintf(fd,'\n---error messages---\n');
  for i=1:size(errors,1)
    mfprintf(fd,errors(i)+'\n');
  end
end

mclose(fd);
