//  Copyright (c) CNES  2008
//
//  This software is part of CelestLab, a CNES toolbox for Scilab
//
//  This software is governed by the CeCILL  license under French law and
//  abiding by the rules of distribution of free software.  You can  use,
//  modify and/ or redistribute the software under the terms of the CeCILL
//  license as circulated by CEA, CNRS and INRIA at the following URL
//  'http://www.cecill.info'.


// Declarations:


// Code:

mode(-1);
path=get_absolute_file_path('test_fr_def_topoN.sce');
chdir(path);
rep1=unix_g('fr_def_topoN.exe');

[fd,err] = mopen('fr_def_topoN_mslib.test','w');

for i=1:size(rep1,1)
  mfprintf(fd,rep1(i)+'\n');
end
mclose(fd);

M_mslib_prov=fscanfMat('fr_def_topoN_mslib.test'); //provisional
[row,col] = size(M_mslib_prov);
lat_mslib = M_mslib_prov(1,1);
lon_mslib = M_mslib_prov(1,2);
i_mslib = M_mslib_prov(2,:);
j_mslib = M_mslib_prov(3,:);
k_mslib = M_mslib_prov(4,:);
M_mslib = [lat_mslib,lon_mslib,i_mslib,j_mslib,k_mslib];

lat = M_mslib(:,1);
lon = M_mslib(:,2);
[i,j,k]=fr_def_topoN(lat',lon');
M_scilab = [lat,lon,i',j',k'];

fprintfMat('fr_def_topoN_mslib.test',M_mslib,'%.17f');
fprintfMat('fr_def_topoN_scilab.test',M_scilab,'%.17f');

//compare values
name='fr_def_topoN';
epsilon=%eps;
uepsilon = strsubst(string(epsilon),'D','e'); //convert precision to unix numeric format
cmd = 'difference -p '+uepsilon+' -ref '+name+'_scilab.test -res '+name+'_mslib.test';
str = '('+cmd+')>'+TMPDIR+'/unix.out 2>'+TMPDIR+'/unix.err;echo $?>'+TMPDIR+'/unix.status';
unix(str); //difference execution

status = read(TMPDIR+'/unix.status',1,1); //0: no difference between files
                                          //1: at least one difference between files
                                          //2: error
output = read(TMPDIR+'/unix.out',-1,1,'(a)');
errors = read(TMPDIR+'/unix.err',-1,1,'(a)');

//write validation
[fd,err] = mopen(name+'.validation','w');
mfprintf(fd,name+'(SpaceLab) vs. fr_def_topo_N(MSLIB)\n---\n');
for i=1:size(output,1)
  mfprintf(fd,output(i)+'\n');
end

if status~=0
  mfprintf(fd,'\n---error messages---\n');
  for i=1:size(errors,1)
    mfprintf(fd,errors(i)+'\n');
  end
end

mclose(fd);
