//  Copyright (c) CNES  2008
//
//  This software is part of CelestLab, a CNES toolbox for Scilab
//
//  This software is governed by the CeCILL  license under French law and
//  abiding by the rules of distribution of free software.  You can  use,
//  modify and/ or redistribute the software under the terms of the CeCILL
//  license as circulated by CEA, CNRS and INRIA at the following URL
//  'http://www.cecill.info'.


// Declarations:


// Code:

mode(-1);
path=get_absolute_file_path('test_fr_ref2topoN.sce');
chdir(path);
rep1=unix_g('fr_ref2topoN.exe');

[fd,err] = mopen('fr_ref2topoN_mslib.test','w');

for i=1:size(rep1,1)
  mfprintf(fd,rep1(i)+'\n');
end
mclose(fd);

M_mslib_prov=fscanfMat('fr_ref2topoN_mslib.test'); //provisional
[row,col] = size(M_mslib_prov);
pos_ref_mslib = M_mslib_prov(1,:)
spd_ref_mslib = M_mslib_prov(2,:)
orig_mslib = M_mslib_prov(3,:);
pos_topo_mslib = M_mslib_prov(4,:)
spd_topo_mslib = M_mslib_prov(5,:)
jacob_mslib = [M_mslib_prov(6,:),M_mslib_prov(7,:);...
               M_mslib_prov(8,:),M_mslib_prov(9,:);...
               M_mslib_prov(10,:),M_mslib_prov(11,:);...
               M_mslib_prov(12,:),M_mslib_prov(13,:);...
               M_mslib_prov(14,:),M_mslib_prov(15,:);...
               M_mslib_prov(16,:),M_mslib_prov(17,:)];
M_mslib = [pos_ref_mslib,spd_ref_mslib,orig_mslib,pos_topo_mslib,spd_topo_mslib,...
           jacob_mslib(1,:),jacob_mslib(2,:),jacob_mslib(3,:),jacob_mslib(4,:),jacob_mslib(5,:),jacob_mslib(6,:)];

pos_ref = M_mslib(:,1:3)
spd_ref = M_mslib(:,4:6)
orig = M_mslib(:,7:9);
[pos_topo,spd_topo,jacob] = fr_ref2topoN(orig',pos_ref',spd_ref');
M_scilab = [pos_ref,spd_ref,orig,pos_topo',spd_topo',...
            jacob(1,:),jacob(2,:),jacob(3,:),jacob(4,:),jacob(5,:),jacob(6,:)];

fprintfMat('fr_ref2topoN_mslib.test',M_mslib,'%.17f');
fprintfMat('fr_ref2topoN_scilab.test',M_scilab,'%.17f');

//compare values
name='fr_ref2topoN';
epsilon=%eps;
uepsilon = strsubst(string(epsilon),'D','e'); //convert precision to unix numeric format
cmd = 'difference -p '+uepsilon+' -ref '+name+'_scilab.test -res '+name+'_mslib.test';
str = '('+cmd+')>'+TMPDIR+'/unix.out 2>'+TMPDIR+'/unix.err;echo $?>'+TMPDIR+'/unix.status';
unix(str); //difference execution

status = read(TMPDIR+'/unix.status',1,1); //0: no difference between files
                                          //1: at least one difference between files
                                          //2: error
output = read(TMPDIR+'/unix.out',-1,1,'(a)');
errors = read(TMPDIR+'/unix.err',-1,1,'(a)');

//write validation
[fd,err] = mopen(name+'.validation','w');
mfprintf(fd,name+'(SpaceLab) vs. mt_ref_topo_N(MSLIB)\n---\n');
for i=1:size(output,1)
  mfprintf(fd,output(i)+'\n');
end

if status~=0
  mfprintf(fd,'\n---error messages---\n');
  for i=1:size(errors,1)
    mfprintf(fd,errors(i)+'\n');
  end
end

mclose(fd);
