//  Copyright (c) CNES  2008
//
//  This software is part of CelestLab, a CNES toolbox for Scilab
//
//  This software is governed by the CeCILL  license under French law and
//  abiding by the rules of distribution of free software.  You can  use,
//  modify and/ or redistribute the software under the terms of the CeCILL
//  license as circulated by CEA, CNRS and INRIA at the following URL
//  'http://www.cecill.info'.


// Declarations:


// Code:

mode(-1);
path=get_absolute_file_path('test_fr_tnw2geo.sce');
chdir(path);
rep1=unix_g('fr_tnw2geo.exe');

[fd,err] = mopen('fr_tnw2geo_mslib.test','w');

for i=1:size(rep1,1)
  mfprintf(fd,rep1(i)+'\n');
end
mclose(fd);

M_mslib_prov=fscanfMat('fr_tnw2geo_mslib.test'); //provisional
[row,col] = size(M_mslib_prov);
i_pos = 1:4:row-3;
i_vit = 2:4:row-2;
i_tnw = 3:4:row-1;
i_geo = 4:4:row;
pos_mslib = M_mslib_prov(i_pos,:);
vit_mslib = M_mslib_prov(i_vit,:);
tnw_mslib = M_mslib_prov(i_tnw,:);
geo_mslib = M_mslib_prov(i_geo,:);
M_mslib = [pos_mslib,vit_mslib,tnw_mslib,geo_mslib];

pos = M_mslib(:,1:3);
vit = M_mslib(:,4:6);
tnw = M_mslib(:,7:9);
[geo]=fr_tnw2geo(pos',vit',tnw');
M_scilab = [pos,vit,tnw,geo'];

fprintfMat('fr_tnw2geo_mslib.test',M_mslib,'%.17f');
fprintfMat('fr_tnw2geo_scilab.test',M_scilab,'%.17f');

//compare values
name='fr_tnw2geo';
epsilon=%eps;
uepsilon = strsubst(string(epsilon),'D','e'); //convert precision to unix numeric format
cmd = 'difference -p '+uepsilon+' -ref '+name+'_scilab.test -res '+name+'_mslib.test';
str = '('+cmd+')>'+TMPDIR+'/unix.out 2>'+TMPDIR+'/unix.err;echo $?>'+TMPDIR+'/unix.status';
unix(str); //difference execution

status = read(TMPDIR+'/unix.status',1,1); //0: no difference between files
                                          //1: at least one difference between files
                                          //2: error
output = read(TMPDIR+'/unix.out',-1,1,'(a)');
errors = read(TMPDIR+'/unix.err',-1,1,'(a)');

//write validation
[fd,err] = mopen(name+'.validation','w');
mfprintf(fd,name+'(SpaceLab) vs. mo_tnw_geo(MSLIB)\n---\n');
for i=1:size(output,1)
  mfprintf(fd,output(i)+'\n');
end

if status~=0
  mfprintf(fd,'\n---error messages---\n');
  for i=1:size(errors,1)
    mfprintf(fd,errors(i)+'\n');
  end
end

mclose(fd);
