//  Copyright (c) CNES  2008
//
//  This software is part of CelestLab, a CNES toolbox for Scilab
//
//  This software is governed by the CeCILL  license under French law and
//  abiding by the rules of distribution of free software.  You can  use,
//  modify and/ or redistribute the software under the terms of the CeCILL
//  license as circulated by CEA, CNRS and INRIA at the following URL
//  'http://www.cecill.info'.


// Declarations:


// Code:

mode(-1);
path=get_absolute_file_path('test_op_omega2beta.sce');
chdir(path);

[data,namecol,unitcol,nb_l_header,header] = rw_madona('EPH_beta_CERES');
beta_psimu = deg2rad(data(:,find(namecol=='BSOL'))');
t_psimu = data(:,find(namecol=='TMPS'))';
cjd = 21184;
sma = 7022000;
exc = 1.2e-5;
inc = deg2rad(82);
gom = 0;
mu = 398593.845654016*1000^3;

[dpom,dgom] = op_J2drift(sma,inc,1.2e-5,mu);

dates = cjd+s2h(t_psimu)/24;

[r_sun,rs] = ep_poluso(dates,'s');
M = fr_G502j2000(dates);
r_sun = M*r_sun;
alpha = atan(r_sun(2,:),r_sun(1,:));
delta = asin(r_sun(3,:));

beta_scilab = op_omega2beta(gom+dgom*t_psimu,alpha,delta,inc);

mprintf('max difference: %.17f in degrees',max(rad2deg(abs(beta_scilab-beta_psimu))))
