//  Copyright (c) CNES  2008
//
//  This software is part of CelestLab, a CNES toolbox for Scilab
//
//  This software is governed by the CeCILL  license under French law and
//  abiding by the rules of distribution of free software.  You can  use,
//  modify and/ or redistribute the software under the terms of the CeCILL
//  license as circulated by CEA, CNRS and INRIA at the following URL
//  'http://www.cecill.info'.


// Declarations:
global %CL_epsilon %CL_writeRef;

// Code:

mode(-1);
path=get_absolute_file_path('reg_CL_mod_nutationAngles.tst.sce');
chdir(path);
epsilon = %CL_epsilon.test

//READ TEST FILE
[fd_test,err] = mopen('test_CL_mod_nutationAngles.txt','r');
test = mgetl(fd_test);
mclose(fd_test);

//GET TEST INFO
i = find(test==''); //i allows to know where is the end of input arguments and function call...
inputs = test(2:i(1)-1);                         //get function inputs
function_call = test(i(2)-1);                    //get function call string
function_data = tokens(function_call,['=','(']);
function_name = function_data(2);                //get function name
outputs =stripblanks(tokens(function_data(1),['[',',',']']));//get function outputs

//OUTPUTS CALCULATION
//execute inputs
execstr(inputs);
//execute function call
execstr(function_call);

//GET OUTPUTS
NUT = evstr(outputs(1));
F = evstr(outputs(2));
NUTP = evstr(outputs(3));
FP = evstr(outputs(4));
NUTPP = evstr(outputs(5));
FPP = evstr(outputs(6));

//BUILD MATRIX
M_reg=[];
for i=1:size(NUT,2)
  M_reg(i,:) = [NUT(:,i)',F(:,i)',NUTP(:,i)',FP(:,i)',NUTPP(:,i)',FPP(:,i)'];
end

//GET REFERENCE MATRIX AND REGRESSION TEST(avoid this part if creating reference files)
[M_ref] = fscanfMat('ref_CL_mod_nutationAngles.txt');
max_error = max( abs(M_reg-M_ref)./(1+abs(M_ref)) );
msg1 = '------'+function_name+' test-----'
//disp(msg1);
if max_error<=epsilon
  msg2 = 'Test passed'
else
  msg2 = 'Test Failed ERROR='+string(max_error)
end
//disp(msg2);

//WRITE FILE (use only to create reference files)
if (exists('%CL_writeRef'))
if (%CL_writeRef)
header = 'NUT1 NUT2 NUT3 NUT4 NUT5 F1 F2 F3 F4 F5 NUTP1 NUTP2 NUTP3 NUTP4 NUTP5 FP1 FP2 FP3 FP4 FP5 NUTPP1 NUTPP2 NUTPP3 NUTPP4 NUTPP5 FPP1 FPP2 FPP3 FPP4 FPP5'
fprintfMat('ref_CL_mod_nutationAngles.txt',M_reg,'%.17f',header);
end
end

clear path epsilon fd_test err test i inputs function_call function_data function_name outputs M_reg M_ref max_error msg1 NUT NUTP NUTPP F FP FPP
