program gp_atmUS76

use mslib

real(pm_reel)                 ::  alt   ! altitude
real(pm_reel)                 ::  tempe ! temperature
real(pm_reel)                 ::  pres  ! pression
real(pm_reel)                 ::  dens  ! densite
type(tm_code_retour)          ::  code_retour
real(pm_reel)       :: rayon0, hpot

!!*************
!!NOMINAL CASES

rayon0 = 6356.766e3_pm_reel

!*********************
!CASE 1: standard case
alt = 120.e3_pm_reel
call mp_atm_US76 (alt, tempe, pres, dens, code_retour)
print *, alt, tempe
print *, pres, dens
!*********************

!*********************
!CASE 2: alt=86km
alt = 86.e3_pm_reel
call mp_atm_US76 (alt, tempe, pres, dens, code_retour)
print *, alt, tempe
print *, pres, dens
!*********************

!*********************
!CASE 3: alt=81km
hpot = 80.e3_pm_reel
alt  = (rayon0 * hpot)/(rayon0 - hpot)
call mp_atm_US76 (alt, tempe, pres, dens, code_retour)
print *, alt, tempe
print *, pres, dens
!*********************

!*********************
!CASE 4: alt=19.962km (hpot=19.9km)
hpot = 19.9e3_pm_reel
alt  = (rayon0 * hpot)/(rayon0 - hpot)
call mp_atm_US76 (alt, tempe, pres, dens, code_retour)
print *, alt, tempe
print *, pres, dens
!*********************

!*********************
!CASE 5: alt=86.5 km
alt  = 86.5e3_pm_reel
call mp_atm_US76 (alt, tempe, pres, dens, code_retour)
print *, alt, tempe
print *, pres, dens
!*********************

!*********************
!CASE 6: alt=100 km
alt  =100.e3_pm_reel
call mp_atm_US76 (alt, tempe, pres, dens, code_retour)
print *, alt, tempe
print *, pres, dens
!*********************

!*********************
!CASE 7: alt=115 km
alt  =115.e3_pm_reel
call mp_atm_US76 (alt, tempe, pres, dens, code_retour)
print *, alt, tempe
print *, pres, dens
!*********************

!!*************
!!DEGRADED CASES

!*********************
!CASE 8: negative altitude
alt  = -2.e3_pm_reel
call mp_atm_US76 (alt, tempe, pres, dens, code_retour)
print *, alt, tempe
print *, pres, dens
!*********************

!*********************
!CASE 9: zero altitude
alt  = 0._pm_reel
call mp_atm_US76 (alt, tempe, pres, dens, code_retour)
print *, alt, tempe
print *, pres, dens
!*********************

!*********************
!CASE 10: 80000
alt  = 80.e3_pm_reel
call mp_atm_US76 (alt, tempe, pres, dens, code_retour)
print *, alt, tempe
print *, pres, dens
!*********************

!*********************
!CASE 11: 87501
alt  = 87501_pm_reel
call mp_atm_US76 (alt, tempe, pres, dens, code_retour)
print *, alt, tempe
print *, pres, dens
!*********************

!*********************
!CASE 12: 87689
alt  = 87689_pm_reel
call mp_atm_US76 (alt, tempe, pres, dens, code_retour)
print *, alt, tempe
print *, pres, dens
!*********************

end program gp_atmUS76