//  Copyright (c) CNES  2008
//
//  This software is part of CelestLab, a CNES toolbox for Scilab
//
//  This software is governed by the CeCILL  license under French law and
//  abiding by the rules of distribution of free software.  You can  use,
//  modify and/ or redistribute the software under the terms of the CeCILL
//  license as circulated by CEA, CNRS and INRIA at the following URL
//  'http://www.cecill.info'.


// Declarations:


// Code:

mode(-1);
path=get_absolute_file_path('test_da_tsid.sce');
chdir(path);
rep1=unix_g('da_tsid.exe');

[fd,err] = mopen('da_tsid_mslib.test','w');

for i=1:size(rep1,1)
  mfprintf(fd,rep1(i)+'\n');
end
mclose(fd);

M_mslib_prov=fscanfMat('da_tsid_mslib.test'); //provisional
day1950_mslib = M_mslib_prov(1,1);
sec1950_mslib = M_mslib_prov(1,2);
ut1_utc_mslib = M_mslib_prov(1,3);
tsid_mslib = M_mslib_prov(2,1);
cjd_mslib = day1950_mslib + sec1950_mslib/3600/24;
M_mslib = [cjd_mslib,tsid_mslib];

cjd = M_mslib(:,1);
tsid=da_tsid(cjd');
M_scilab = [cjd,tsid'];

fprintfMat('da_tsid_mslib.test',M_mslib,'%.17f');
fprintfMat('da_tsid_scilab.test',M_scilab,'%.17f');

//compare values
name='da_tsid';
epsilon=%eps;
uepsilon = strsubst(string(epsilon),'D','e'); //convert precision to unix numeric format
cmd = 'difference -p '+uepsilon+' -ref '+name+'_scilab.test -res '+name+'_mslib.test';
str = '('+cmd+')>'+TMPDIR+'/unix.out 2>'+TMPDIR+'/unix.err;echo $?>'+TMPDIR+'/unix.status';
unix(str); //difference execution

status = read(TMPDIR+'/unix.status',1,1); //0: no difference between files
                                          //1: at least one difference between files
                                          //2: error
output = read(TMPDIR+'/unix.out',-1,1,'(a)');
errors = read(TMPDIR+'/unix.err',-1,1,'(a)');

//write validation
[fd,err] = mopen(name+'.validation','w');
mfprintf(fd,name+'(SpaceLab) vs. md_calend_julien(MSLIB)\n---\n');
for i=1:size(output,1)
  mfprintf(fd,output(i)+'\n');
end

if status~=0
  mfprintf(fd,'\n---error messages---\n');
  for i=1:size(errors,1)
    mfprintf(fd,errors(i)+'\n');
  end
end

mclose(fd);
