//  Copyright (c) CNES  2008
//
//  This software is part of CelestLab, a CNES toolbox for Scilab
//
//  This software is governed by the CeCILL  license under French law and
//  abiding by the rules of distribution of free software.  You can  use,
//  modify and/ or redistribute the software under the terms of the CeCILL
//  license as circulated by CEA, CNRS and INRIA at the following URL
//  'http://www.cecill.info'.


// Declarations:


// Code:

mode(-1);
path=get_absolute_file_path('test_ep_poluso.sce');
chdir(path);
rep1=unix_g('ep_poluso.exe');

[fd,err] = mopen('ep_poluso_mslib.test','w');

for i=1:size(rep1,1)
  mfprintf(fd,rep1(i)+'\n');
end
mclose(fd);

M_mslib_prov=fscanfMat('ep_poluso_mslib.test'); //provisional
[row,col] = size(M_mslib_prov);
i1 = 1:5:row-4;
i2 = 2:5:row-3;
i3 = 3:5:row-2;
i4 = 4:5:row-1;
i5 = 5:5:row;
cjd_mslib = M_mslib_prov(i1,1);
cjdsec_mslib = M_mslib_prov(i1,2);
dirsol_mslib = M_mslib_prov(i2,:);
distsol_mslib = M_mslib_prov(i3,1);
dirlune_mslib = M_mslib_prov(i4,:);
distlune_mslib = M_mslib_prov(i5,1);
M_mslib = [cjd_mslib,cjdsec_mslib,dirsol_mslib,distsol_mslib,dirlune_mslib,distlune_mslib];

cjd_day = M_mslib(:,1);
cjd_sec = M_mslib(:,2);
cjd = cjd_day + cjd_sec./3600./24
[dirlune,distlune,dirsol,distsol] = ep_poluso(cjd');
M_scilab = [cjd_day,cjd_sec,dirsol',m2km(distsol'),dirlune',m2km(distlune')];

fprintfMat('ep_poluso_mslib.test',M_mslib,'%.17f');
fprintfMat('ep_poluso_scilab.test',M_scilab,'%.17f');

//compare values
name='ep_poluso';
epsilon=%eps;
uepsilon = strsubst(string(epsilon),'D','e'); //convert precision to unix numeric format
cmd = 'difference -p '+uepsilon+' -ref '+name+'_scilab.test -res '+name+'_mslib.test';
str = '('+cmd+')>'+TMPDIR+'/unix.out 2>'+TMPDIR+'/unix.err;echo $?>'+TMPDIR+'/unix.status';
unix(str); //difference execution

status = read(TMPDIR+'/unix.status',1,1); //0: no difference between files
                                          //1: at least one difference between files
                                          //2: error
output = read(TMPDIR+'/unix.out',-1,1,'(a)');
errors = read(TMPDIR+'/unix.err',-1,1,'(a)');

//write validation
[fd,err] = mopen(name+'.validation','w');
mfprintf(fd,name+'(SpaceLab) vs. ms_pos_soleil_lune(MSLIB)\n---\n');
for i=1:size(output,1)
  mfprintf(fd,output(i)+'\n');
end

if status~=0
  mfprintf(fd,'\n---error messages---\n');
  for i=1:size(errors,1)
    mfprintf(fd,errors(i)+'\n');
  end
end

mclose(fd);
