//  Copyright (c) CNES  2008
//
//  This software is part of CelestLab, a CNES toolbox for Scilab
//
//  This software is governed by the CeCILL  license under French law and
//  abiding by the rules of distribution of free software.  You can  use,
//  modify and/ or redistribute the software under the terms of the CeCILL
//  license as circulated by CEA, CNRS and INRIA at the following URL
//  'http://www.cecill.info'.


// Declarations:


// Code:

mode(-1);
path=get_absolute_file_path('test_gp_atmUS76.sce');
chdir(path);

rep1=unix_g('gp_atmUS76.exe');

[fd,err] = mopen('gp_atmUS76_mslib.test','w');

for i=1:size(rep1,1)
  mfprintf(fd,rep1(i)+'\n');
end
mclose(fd);

M_mslib_prov=fscanfMat('gp_atmUS76_mslib.test'); //provisional
[row,col] = size(M_mslib_prov);
i_alt = 1:2:23
i_temp = 1:2:23
i_pres = 2:2:24
i_dens = 2:2:24
alt_mslib = M_mslib_prov(i_alt,1);
temp_mslib = M_mslib_prov(i_temp,2);
pres_mslib = M_mslib_prov(i_pres,1);
dens_mslib = M_mslib_prov(i_dens,2);
M_mslib = [alt_mslib,temp_mslib,pres_mslib,dens_mslib];

alt = M_mslib(:,1);
[temp,pres,dens] = gp_atmUS76(alt');
M_scilab = [alt,temp',pres',dens'];

fprintfMat('gp_atmUS76_mslib.test',M_mslib,'%.17f');
fprintfMat('gp_atmUS76_scilab.test',M_scilab,'%.17f');

//compare values
name='gp_atmUS76';
epsilon=%eps;
uepsilon = strsubst(string(epsilon),'D','e'); //convert precision to unix numeric format
cmd = 'difference -p '+uepsilon+' -ref '+name+'_scilab.test -res '+name+'_mslib.test';
str = '('+cmd+')>'+TMPDIR+'/unix.out 2>'+TMPDIR+'/unix.err;echo $?>'+TMPDIR+'/unix.status';
unix(str); //difference execution

status = read(TMPDIR+'/unix.status',1,1); //0: no difference between files
                                          //1: at least one difference between files
                                          //2: error
output = read(TMPDIR+'/unix.out',-1,1,'(a)');
errors = read(TMPDIR+'/unix.err',-1,1,'(a)');

//write validation
[fd,err] = mopen(name+'.validation','w');
mfprintf(fd,name+'(SpaceLab) vs. mp_atm_US76(MSLIB)\n---\n');
for i=1:size(output,1)
  mfprintf(fd,output(i)+'\n');
end

if status~=0
  mfprintf(fd,'\n---error messages---\n');
  for i=1:size(errors,1)
    mfprintf(fd,errors(i)+'\n');
  end
end

mclose(fd);


