//  Copyright (c) CNES  2008
//
//  This software is part of CelestLab, a CNES toolbox for Scilab
//
//  This software is governed by the CeCILL  license under French law and
//  abiding by the rules of distribution of free software.  You can  use,
//  modify and/ or redistribute the software under the terms of the CeCILL
//  license as circulated by CEA, CNRS and INRIA at the following URL
//  'http://www.cecill.info'.


// Declarations:
global %CL_epsilon %CL_writeRef;

// Code:

mode(-1);
path=get_absolute_file_path('reg_CL_op_driftJ2.tst.sce');
chdir(path);
epsilon = %CL_epsilon.test

//READ TEST FILE
[fd_test,err] = mopen('test_CL_op_driftJ2.txt','r');
test = mgetl(fd_test);
mclose(fd_test);

//GET TEST INFO
i = find(test==''); //i allows to know where is the end of input arguments and function call...
inputs = test(2:i(1)-1);                         //get function inputs
function_call = test(i(2)-1);                    //get function call string
function_data = tokens(function_call,['=','(']);
function_name = function_data(2);                //get function name
outputs =stripblanks(tokens(function_data(1),['[',',',']']));//get function outputs

//OUTPUTS CALCULATION
//execute inputs
execstr(inputs);
//execute function call
execstr(function_call);

//GET OUTPUTS
dpom = evstr(outputs(1));
dgom = evstr(outputs(2));
dM = evstr(outputs(3));
dpomdaei = evstr(outputs(4));
dgomdaei = evstr(outputs(5));
dMdaei = evstr(outputs(6));

//BUILD MATRIX
M_reg=[];
for i=1:size(dpom,2)
  M_reg(i,:) = [dpom(i),dgom(i),dM(i),dpomdaei(1,i),dpomdaei(2,i),dpomdaei(3,i),..
                dgomdaei(1,i),dgomdaei(2,i),dgomdaei(3,i),dMdaei(1,i),dMdaei(2,i),dMdaei(3,i)];
end

//GET REFERENCE MATRIX AND REGRESSION TEST(avoid this part if creating reference files)
[M_ref] = fscanfMat('ref_CL_op_driftJ2.txt');
max_error = max( abs(M_reg-M_ref)./(1+abs(M_ref)) );
msg1 = '------'+function_name+' test-----'
//disp(msg1);
if max_error<=epsilon
  msg2 = 'Test passed'
else
  msg2 = 'Test Failed ERROR='+string(max_error)
end
//disp(msg2);

//WRITE FILE (use only to create reference files)
if (exists('%CL_writeRef'))
if (%CL_writeRef)
header = 'd_pom d_gom d_M d_dpom/da d_dpom/de d_dpom/di d_dgom/da d_dgom/de d_dgom/di d_dM/da d_dM/de d_dM/di'
fprintfMat('ref_CL_op_driftJ2.txt',M_reg,'%.17f',header);
end
end

clear path epsilon fd_test err test i inputs function_call function_data function_name outputs M_reg M_ref max_error msg1 dpom dgom dM dpomdaei dgomdaei dMdaei
