program kp_kepler_E

use mslib

real(pm_reel) :: ANOM_M
real(pm_reel) :: E
real(pm_reel) :: ANOM_E
type(tm_code_retour) :: CODE_RETOUR

!!*************
!!NOMINAL CASES

!****************************
!CASE 1: random standard case
ANOM_M = 2.618_pm_reel
E =      0.9_pm_reel
call mv_kepler_std(ANOM_M,E,ANOM_E,CODE_RETOUR)
print *, ANOM_M, E, ANOM_E
!****************************

!****************************
!CASE 2: circular orbit
ANOM_M = 0.785398163397095_pm_reel
E =      0.5e-12_pm_reel 		!circular orbit
call mv_kepler_std(ANOM_M,E,ANOM_E,CODE_RETOUR)
print *, ANOM_M, E, ANOM_E
!****************************

!****************************
!CASE 3: sin(ANOM_M) near 0 (odd pi multiple)
ANOM_M = 0.314159265358979e1_pm_reel
E =      0.3_pm_reel 	
call mv_kepler_std(ANOM_M,E,ANOM_E,CODE_RETOUR)
print *, ANOM_M, E, ANOM_E
!****************************

!****************************
!CASE 4: sin(ANOM_M) near 0 (par pi multiple)
ANOM_E = 1.e-14_pm_reel + 4._pm_reel*pi
E =      0.5_pm_reel 
ANOM_M = ANOM_E - E *sin(ANOM_E)	
call mv_kepler_std(ANOM_M,E,ANOM_E,CODE_RETOUR)
print *, ANOM_M, E, ANOM_E
!****************************


end program kp_kepler_E
