program kp_kepler_hyperb

use mslib

real(pm_reel) :: anom_M   ! anomalie moyenne (M)
real(pm_reel) :: e        ! excentricite (e)
real(pm_reel) :: anom_E   ! anomalie excentrique (E) 
type(tm_code_retour) :: CODE_RETOUR

!!*************
!!NOMINAL CASES

!*********************
!CASE 1: random case
e = 1.7311_pm_reel
anom_M = 0.048363_pm_reel
call mvi_kepler_hyperb(anom_M,e,anom_E,CODE_RETOUR)
print *, anom_M, e, anom_E
!*********************

!*********************
!CASE 2: anom_M<=1 and e<=1.05
e = 1.03_pm_reel
anom_M = 0.9_pm_reel
call mvi_kepler_hyperb(anom_M,e,anom_E,CODE_RETOUR)
print *, anom_M, e, anom_E
!*********************

!*********************
!CASE 3: anom_M<=1 and e<=1.05 and anom_M<0
e = 1.03_pm_reel
anom_M = -0.2_pm_reel
call mvi_kepler_hyperb(anom_M,e,anom_E,CODE_RETOUR)
print *, anom_M, e, anom_E
!*********************

!*********************
!CASE 4: anom_M>1 or e>1.05
e = 1.06_pm_reel
anom_M = 0.9_pm_reel
call mvi_kepler_hyperb(anom_M,e,anom_E,CODE_RETOUR)
print *, anom_M, e, anom_E
!*********************

!*********************
!CASE 5: anom_M>1 or e>1.05
e = 1.03_pm_reel
anom_M = 1.3_pm_reel
call mvi_kepler_hyperb(anom_M,e,anom_E,CODE_RETOUR)
print *, anom_M, e, anom_E
!*********************

!*********************
!CASE 6: anom_M>1 or e>1.05
e = 1.06_pm_reel
anom_M = 1.3_pm_reel
call mvi_kepler_hyperb(anom_M,e,anom_E,CODE_RETOUR)
print *, anom_M, e, anom_E
!*********************

end program kp_kepler_hyperb
