//  Copyright (c) CNES  2008
//
//  This software is part of CelestLab, a CNES toolbox for Scilab
//
//  This software is governed by the CeCILL  license under French law and
//  abiding by the rules of distribution of free software.  You can  use,
//  modify and/ or redistribute the software under the terms of the CeCILL
//  license as circulated by CEA, CNRS and INRIA at the following URL
//  'http://www.cecill.info'.

//execute mslib test

// Declarations:


// Code:

mode(-1);
path=get_absolute_file_path('test_kp_kepler_E.sce');
chdir(path);
rep1=unix_g('kp_kepler_E.exe');

//save mslib outputs
[fd,err] = mopen('kp_kepler_E_mslib.test','w');
for i=1:size(rep1,1)
  mfprintf(fd,rep1(i)+'\n');
end
mclose(fd);


M_mslib=fscanfMat('kp_kepler_E_mslib.test');
anom_M = M_mslib(:,1);
e = M_mslib(:,2);
anom_E=kp_kepler_E(e',anom_M')';
M_scilab = [anom_M,e,anom_E];
fprintfMat('kp_kepler_E_mslib.test',M_mslib,'%.17f');
fprintfMat('kp_kepler_E_scilab.test',M_scilab,'%.17f');

//compare values
name='kp_kepler_E';
epsilon=%eps;
uepsilon = strsubst(string(epsilon),'D','e'); //convert precision to unix numeric format
cmd = 'difference -p '+uepsilon+' -ref '+name+'_scilab.test -res '+name+'_mslib.test';
str = '('+cmd+')>'+TMPDIR+'/unix.out 2>'+TMPDIR+'/unix.err;echo $?>'+TMPDIR+'/unix.status';
unix(str); //difference execution

status = read(TMPDIR+'/unix.status',1,1); //0: no difference between files
                                          //1: at least one difference between files
                                          //2: error
output = read(TMPDIR+'/unix.out',-1,1,'(a)');
errors = read(TMPDIR+'/unix.err',-1,1,'(a)');

//write validation
[fd,err] = mopen('kp_kepler_E.validation','w');
mfprintf(fd,name+'(SpaceLab) vs. mv_kepler_std(MSLIB)\n---\n');
for i=1:size(output,1)
  mfprintf(fd,output(i)+'\n');
end

if status~=0
  mfprintf(fd,'\n---error messages---\n');
  for i=1:size(errors,1)
    mfprintf(fd,errors(i)+'\n');
  end
end

mclose(fd);







