//  Copyright (c) CNES  2008
//
//  This software is part of CelestLab, a CNES toolbox for Scilab
//
//  This software is governed by the CeCILL  license under French law and
//  abiding by the rules of distribution of free software.  You can  use,
//  modify and/ or redistribute the software under the terms of the CeCILL
//  license as circulated by CEA, CNRS and INRIA at the following URL
//  'http://www.cecill.info'.


// Declarations:


// Code:

mode(-1);
path=get_absolute_file_path('test_op_J2derive.sce');
chdir(path);
rep1=unix_g('op_J2derive.exe');

[fd,err] = mopen('op_J2derive_mslib.test','w');

for i=1:size(rep1,1)
  mfprintf(fd,rep1(i)+'\n');
end
mclose(fd);

M_mslib_prov=fscanfMat('op_J2derive_mslib.test'); //provisional
a_mslib = M_mslib_prov(1,1);
e_mslib = M_mslib_prov(1,2);
i_mslib = M_mslib_prov(1,3);
pom_mslib = M_mslib_prov(3,1);
gom_mslib = M_mslib_prov(3,2);
mu = M_mslib_prov(2,1);
c20 = M_mslib_prov(2,2);
r_equa = M_mslib_prov(2,3);
m_mslib = M_mslib_prov(3,3);
M_mslib = [a_mslib,e_mslib,i_mslib,pom_mslib,gom_mslib,m_mslib];

a = M_mslib(:,1);
e = M_mslib(:,2);
i = M_mslib(:,3);
[pom,gom,M]=op_J2drift(a',i',e',mu',r_equa',-c20');
M_scilab = [a,e,i,pom',gom',M'];

fprintfMat('op_J2derive_mslib.test',M_mslib,'%.17f');
fprintfMat('op_J2derive_scilab.test',M_scilab,'%.17f');

//compare values
name='op_J2derive';
epsilon=%eps;
uepsilon = strsubst(string(epsilon),'D','e'); //convert precision to unix numeric format
cmd = 'difference -p '+uepsilon+' -ref '+name+'_scilab.test -res '+name+'_mslib.test';
str = '('+cmd+')>'+TMPDIR+'/unix.out 2>'+TMPDIR+'/unix.err;echo $?>'+TMPDIR+'/unix.status';
unix(str); //difference execution

status = read(TMPDIR+'/unix.status',1,1); //0: no difference between files
                                          //1: at least one difference between files
                                          //2: error
output = read(TMPDIR+'/unix.out',-1,1,'(a)');
errors = read(TMPDIR+'/unix.err',-1,1,'(a)');

//write validation
[fd,err] = mopen(name+'.validation','w');
mfprintf(fd,name+'(SpaceLab) vs. me_deriv_secul_J2(MSLIB)\n---\n');
for i=1:size(output,1)
  mfprintf(fd,output(i)+'\n');
end

if status~=0
  mfprintf(fd,'\n---error messages---\n');
  for i=1:size(errors,1)
    mfprintf(fd,errors(i)+'\n');
  end
end

mclose(fd);
