//  Copyright (c) CNES  2008
//
//  This software is part of CelestLab, a CNES toolbox for Scilab
//
//  This software is governed by the CeCILL  license under French law and
//  abiding by the rules of distribution of free software.  You can  use,
//  modify and/ or redistribute the software under the terms of the CeCILL
//  license as circulated by CEA, CNRS and INRIA at the following URL
//  'http://www.cecill.info'.


// Declarations:
global %CL_epsilon %CL_writeRef;

// Code:

mode(-1);
path=get_absolute_file_path('reg_CL_cw_Mmatrix.tst.sce');
chdir(path);
epsilon = %CL_epsilon.test

//READ TEST FILE
[fd_test,err] = mopen('test_CL_cw_Mmatrix.txt','r');
test = mgetl(fd_test);
mclose(fd_test);

//GET TEST INFO
i = find(test==''); //i allows to know where is the end of input arguments and function call...
inputs = test(2:i(1)-1);                         //get function inputs
function_call = test(i(2)-1);                    //get function call string
function_data = tokens(function_call,['=','(']);
function_name = function_data(2);                //get function name
outputs = stripblanks(tokens(function_data(1),['[',',',']']));//get function outputs


//OUTPUTS CALCULATION
//execute inputs
execstr(inputs);
//execute function call
execstr(function_call);

//GET OUTPUTS
M1 = evstr(outputs);

//BUILD MATRIX
M_reg = [];
for i=1:size(M1,3)
  M_reg(i,:) = [M1(1,:,i) M1(2,:,i) M1(3,:,i) M1(4,:,i) M1(5,:,i) M1(6,:,i)];
end

//GET REFERENCE MATRIX AND REGRESSION TEST(avoid this part if creating reference files)
[M_ref] = fscanfMat('ref_CL_cw_Mmatrix.txt');
max_error = max( abs(M_reg-M_ref)./(1+abs(M_ref)) );
msg1 = '------'+function_name+' test-----'
//disp(msg1);
if max_error<=epsilon
  msg2 = 'Test passed'
else
  msg2 = 'Test Failed ERROR='+string(max_error)
end
//disp(msg2);

//WRITE FILE (use only to create reference files)
if (exists('%CL_writeRef'))
if (%CL_writeRef)
header = 'M11 M12 M13 M14 M15 M16 M21 M22 M23 M24 M25 M26 M31 M32 M33 M34 M35 M36 M41 M42 M43 M44 M45 M46 M51 M52 M53 M54 M55 M56 M61 M62 M63 M64 M65 M66'
fprintfMat('ref_CL_cw_Mmatrix.txt',M_reg,'%.17f',header);
end
end

clear path epsilon fd_test err test i inputs function_call function_data function_name outputs M_reg M_ref max_error msg1 M1
