//  Copyright (c) CNES  2008
//
//  This software is part of CelestLab, a CNES toolbox for Scilab
//
//  This software is governed by the CeCILL  license under French law and
//  abiding by the rules of distribution of free software.  You can  use,
//  modify and/ or redistribute the software under the terms of the CeCILL
//  license as circulated by CEA, CNRS and INRIA at the following URL
//  'http://www.cecill.info'.


// Declarations:
global %CL_epsilon %CL_writeRef;

// Code:

mode(-1);
path=get_absolute_file_path('reg_CL_cw_Nmatrix.tst.sce');
chdir(path);
epsilon = %CL_epsilon.test

//READ TEST FILE
[fd_test,err] = mopen('test_CL_cw_Nmatrix.txt','r');
test = mgetl(fd_test);
mclose(fd_test);

//GET TEST INFO
i = find(test==''); //i allows to know where is the end of input arguments and function call...
inputs = test(2:i(1)-1);                         //get function inputs
function_call = test(i(2)-1);                    //get function call string
function_data = tokens(function_call,['=','(']);
function_name = function_data(2);                //get function name
outputs = stripblanks(tokens(function_data(1),['[',',',']']));//get function outputs

//OUTPUTS CALCULATION
//execute inputs
execstr(inputs);
//execute function call
execstr(function_call);

//GET OUTPUTS
N2 = evstr(outputs);

//BUILD MATRIX
M_reg = [];
for i=1:size(N2,3)
  M_reg(i,:) = [N2(1,:,i) N2(2,:,i) N2(3,:,i) N2(4,:,i) N2(5,:,i) N2(6,:,i)];
end

//GET REFERENCE MATRIX AND REGRESSION TEST(avoid this part if creating reference files)
[M_ref] = fscanfMat('ref_CL_cw_Nmatrix.txt');
max_error = max( abs(M_reg-M_ref)./(1+abs(M_ref)) );
msg1 = '------'+function_name+' test-----'
//disp(msg1);
if max_error<=epsilon
  msg2 = 'Test passed'
else
  msg2 = 'Test Failed ERROR='+string(max_error)
end
//disp(msg2);

//WRITE FILE (use only to create reference files)
if (exists('%CL_writeRef'))
if (%CL_writeRef)
header = 'N11 N12 N13 N14 N15 N16 N21 N22 N23 N24 N25 N26 N31 N32 N33 N34 N35 N36 N41 N42 N43 N44 N45 N46 N51 N52 N53 N54 N55 N56 N61 N62 N63 N64 N65 N66'
fprintfMat('ref_CL_cw_Nmatrix.txt',M_reg,'%.17f',header);
end
end

clear path epsilon fd_test err test i inputs function_call function_data function_name outputs M_reg M_ref max_error msg1 N2
