//  Copyright (c) CNES  2008
//
//  This software is part of CelestLab, a CNES toolbox for Scilab
//
//  This software is governed by the CeCILL  license under French law and
//  abiding by the rules of distribution of free software.  You can  use,
//  modify and/ or redistribute the software under the terms of the CeCILL
//  license as circulated by CEA, CNRS and INRIA at the following URL
//  'http://www.cecill.info'.


// Declarations:


// Code:

mode(-1);
path=get_absolute_file_path('test_sc2angle.sce');
chdir(path);

rep1=unix_g('sc2angle.exe');  //execute mslib fortran90 test

//write outputs
[fd,err] = mopen('sc2angle_mslib.test','w');
for i=1:size(rep1,1)
  mfprintf(fd,rep1(i)+'\n');
end
mclose(fd);

M_mslib=fscanfMat('sc2angle_mslib.test'); //get mslib outputs
//get function inputs
x = M_mslib(:,1);
y = M_mslib(:,2);
//compute outputs with scilab function
alpha=sc2angle(x',y')';
M_scilab = [x,y,alpha];

//print mslib and scilab outputs (same format to compare)
fprintfMat('sc2angle_mslib.test',M_mslib,'%.17f','x y alpha');
fprintfMat('sc2angle_scilab.test',M_scilab,'%.17f','x y alpha');

//compare values
name='sc2angle';
epsilon=%eps;
uepsilon = strsubst(string(epsilon),'D','e'); //convert precision to unix numeric format
cmd = 'difference -p '+uepsilon+' -ref '+name+'_scilab.test -res '+name+'_mslib.test';
str = '('+cmd+')>'+TMPDIR+'/unix.out 2>'+TMPDIR+'/unix.err;echo $?>'+TMPDIR+'/unix.status';
unix(str); //difference execution
status = read(TMPDIR+'/unix.status',1,1); //0: no difference between files
                                          //1: at least one difference between files
                                          //2: error
output = read(TMPDIR+'/unix.out',-1,1,'(a)');

//write validation
[fd,err] = mopen('sc2angle.validation','w');
mfprintf(fd,name+'(SpaceLab) vs. mu_angle2(MSLIB)\n---\n');
for i=1:size(output,1)
  mfprintf(fd,output(i)+'\n');
end
mclose(fd);


