//  Copyright (c) CNES  2008
//
//  This software is part of CelestLab, a CNES toolbox for Scilab
//
//  This software is governed by the CeCILL  license under French law and
//  abiding by the rules of distribution of free software.  You can  use,
//  modify and/ or redistribute the software under the terms of the CeCILL
//  license as circulated by CEA, CNRS and INRIA at the following URL
//  'http://www.cecill.info'.


// Declarations:


// Code:

mode(-1);
path=get_absolute_file_path('test_vect_angle.sce');
chdir(path);

rep1=unix_g('vect_angle.exe');  //execute mslib fortran90 test

//write outputs
[fd,err] = mopen('vect_angle_mslib.test','w');
for i=1:size(rep1,1)
  mfprintf(fd,rep1(i)+'\n');
end
mclose(fd);

M_mslib_prov=fscanfMat('vect_angle_mslib.test'); //get mslib outputs
//get function inputs
i_u = 1
i_v = 2
i_angle = 3
u_mslib = M_mslib_prov(i_u,1:3);
v_mslib = M_mslib_prov(i_v,1:3);
angle_mslib = M_mslib_prov(i_angle,1);
M_mslib = [u_mslib, v_mslib, angle_mslib]

//compute outputs with scilab function
u = M_mslib(:,1:3)
v = M_mslib(:,4:6)
angle=vect_angle(u',v');
M_scilab = [u,v,angle'];

//print mslib and scilab outputs (same format to compare)
fprintfMat('vect_angle_mslib.test',M_mslib,'%.17f','ux uy uz vx vy vz angle');
fprintfMat('vect_angle_scilab.test',M_scilab,'%.17f','ux uy uz vx vy vz angle');

//compare values
name='vect_angle';
epsilon=%eps;
uepsilon = strsubst(string(epsilon),'D','e'); //convert precision to unix numeric format
cmd = 'difference -p '+uepsilon+' -ref '+name+'_scilab.test -res '+name+'_mslib.test';
str = '('+cmd+')>'+TMPDIR+'/unix.out 2>'+TMPDIR+'/unix.err;echo $?>'+TMPDIR+'/unix.status';
unix(str); //difference execution
status = read(TMPDIR+'/unix.status',1,1); //0: no difference between files
                                          //1: at least one difference between files
                                          //2: error
output = read(TMPDIR+'/unix.out',-1,1,'(a)');

//write validation
[fd,err] = mopen('vect_angle.validation','w');
mfprintf(fd,name+'(SpaceLab) vs. mu_angle3(MSLIB)\n---\n');
for i=1:size(output,1)
  mfprintf(fd,output(i)+'\n');
end
mclose(fd);


